#!/bin/sh -e
############### Begin Standard Header - Do not add comments here ###############
# 
# File:     workspace/install/setupImage/bin/si_inst.sh, si_install, si_dev
# Version:  1.30.1.6
# Modified: 4/6/06 12:16:06
# Build:    1 30
# 
# Licensed Materials - Property of IBM
# 
# Restricted Materials of IBM
# 
# ACOM-SIT
# 
# (C) COPYRIGHT IBM CORP. 2003, 2006.  All Rights Reserved.
# 
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
############################# End Standard Header ##############################
#
# @version 1.2
# @author Kathleen Harlow
#
# Defect   Name       Date           Description
# -------  ---------  -------------  ------------------------------------
#
# Feature  Name       Date           Description
# -------  ---------  -------------  ------------------------------------
# 0000545  kat        20030922       Modified install scripts to use new install 
# 0000545  Doug       20031003       Modified input parms and usage statement
# 0003476  mbelvin    20040820       Added installMode java property
# 0003582  mbelvin    20040902       Update uninstall to pass acu.commonLocation property
# 0003861  mbelvin    20040921       Update static syntax usage statement
# 0005166  mbelvin    20050107       Add support for use of copied JRE
# 0005244  mbelvin    20050112       Unset env value on uninstall
# 0005395  mbelvin    20050121       Address case where ""/bin/java actually exists
# 0007173  smurphy    20050607       Fix awt toolkit references
# 0007280  smurphy    20050609       remove headless awt property
# 0009449  waciii     20051202       -javaHome must be 1st arg to avoid parsing error
#
# For supported syntax:
#     si_inst.sh -?
#
#
#########################################################################
 
progname=`echo $0 | sed -e 's%\\\\%/%g'`
DIRNAME=`dirname "$progname"`
DATA_PATH="$DIRNAME/.data"
ARGS_IN="CLI_INVOKED $*"      # CLI Called flag
JAVA_EXE="java"


if [ "$1" = "-javaHome" ] ; then
   SI_JAVA_HOME=$2
fi  

if [ "${SI_JAVA_HOME}" != "" ] ; then
   if [ -f "${SI_JAVA_HOME}/bin/java" ] ; then
      JAVA_EXE="${SI_JAVA_HOME}/bin/java"
   elif [ -f "${SI_JAVA_HOME}/jre/bin/java" ] ; then
      JAVA_EXE="${SI_JAVA_HOME}/jre/bin/java"
   fi
fi


# Start the installer based on location
if [ -f .data/setup.jar ]; then

   $JAVA_EXE '-Dacu.installMode=$(acu.installMode)' '-Dacu.commonLocation=$(acu.commonLocation)' -jar .data/setup.jar $ARGS_IN
else
   $JAVA_EXE '-Dacu.installMode=$(acu.installMode)' '-Dacu.commonLocation=$(acu.commonLocation)' -jar "${DATA_PATH}/setup.jar" $ARGS_IN
fi

