@rem #########################################################################
@rem # IBM Confidential
@rem # OCO Source Materials
@rem # 5724-S51
@rem #
@rem # (C) Copyright IBM Corp. 2008  All Rights Reserved.
@rem #
@rem # The source code for this program is not published or otherwise
@rem # divested of its trade secrets, irrespective of what has been
@rem # deposited with the U.S. Copyright Office.
@rem #########################################################################
@echo off
setlocal

rem -------------------------------------------------------
rem Wrapper script for IBM Tivoli Netcool Migration Tool
rem -------------------------------------------------------

rem Set up MIGRATION_HOME
set CUR_DIR=%cd%
cd /d "%~dp0.."
set MIGRATION_HOME=%cd%
cd /d "%CUR_DIR%"

rem Check NCHOME.
if not exist "%NCHOME%" (
	goto badnchome
)

rem Check NCSMHOME
set NCSMHOME=%NCHOME%\security
if not exist "%NCSMHOME%" (
  goto badncsmhome
)

set JAVA="%NCHOME%\platform\win32\jre_1.5.0\bin\java.exe"
if not exist %JAVA% (
  set JAVA="%JAVA_HOME%\bin\java.exe"
)

rem Check Java binary
if not exist %JAVA% goto nojava

rem Set up Java system properties.
set SYSPROP_MIGRATIONHOME=-Dmigration.home="%MIGRATION_HOME%"
set SYSPROP_LOGCLASS=-Djava.util.logging.config.class=com.ibm.tivoli.nc.migration.logging.LogManagerInitializer
set SYSPROP_NCHOME=-Dnchome="%NCHOME%"
set SYSPROP_TIPHOME=-Dtiphome="%TIPHOME%"
set SYSPROP_PLUGINS_LIST=-Dmigration.pluginslist="%MIGRATION_HOME%\etc\sm_export.lst"

set SYSPROPS=%SYSPROP_MIGRATIONHOME% %SYSPROP_LOGCLASS% %SYSPROP_TIPHOME% %SYSPROP_PLUGINS_LIST% %SYSPROP_NCHOME%

rem Set up classpath and execute migrator.
set CLASSPATH=.

rem set ibmjce jar to classpath
for %%i in ("%NCSMHOME%\lib\ibmjce*.jar") do (
call setClasspath.bat "%%i" 
)

rem set ibmpkcs jar to classpath
for %%i in ("%NCSMHOME%\lib\ibmpkcs*.jar") do (
call setClasspath.bat "%%i" 
)

rem set ncsm3p jar to classpath
for %%i in ("%NCSMHOME%\lib3p\ncsm3p*.jar") do (
call setClasspath.bat "%%i" 
)

rem set nci3p jar to classpath
for %%i in ("%NCSMHOME%\lib3p\nci3p*.jar") do (
call setClasspath.bat "%%i" 
)

rem set nccommon jar for SM 1.3 to classpath
for %%i in ("%NCSMHOME%\lib\nccommon*.jar") do (
call setClasspath.bat "%%i" 
)

rem set nci jar to classpath
for %%i in ("%NCSMHOME%\lib\nci*.jar") do (
call setClasspath.bat "%%i" 
)

rem set all jar in migration tool lib to classpath
for %%i in ("%MIGRATION_HOME%\lib\*.jar") do (
call setClasspath.bat "%%i" 
)

%JAVA% -Xmx64m %SYSPROPS% -cp %CLASSPATH% com.ibm.tivoli.nc.migration.MigrationExportTool %*
endlocal
exit /B %errorlevel%

:nojava
echo No Java runtime environment found.
echo Please check if NCHOME environment variable points to a Tivoli Netcool
echo installation with IBM Tivoli Netcool Security Manager installed.
endlocal
exit /B 5

:badnchome
echo The environment variable NCHOME has not been set correctly.
echo Please set the NCHOME environment variable to point to a Tivoli Netcool
echo installation with an IBM Tivoli Netcool product installed.
endlocal
exit /B 4

:badncsmhome
echo No Netcool Security Manager found in %NCHOME%\security.
echo Please set the NCHOME environment variable to point to a Tivoli Netcool
echo installation with IBM Tivoli Netcool Security Manager installed.
endlocal
exit /B 4
