<?xml version="1.0" encoding="UTF-8" ?>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ include file="/common/taglibs.jsp" %>

<fmt:setBundle basename="ncw.nl.tooleditor" var="langset" scope="request"/>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html:html xhtml="true">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title><fmt:message key="page.title" bundle="${langset}"/></title>

<html:base />

<link rel="stylesheet" type="text/css" href="../styles/styles.css" />
<link rel="stylesheet" type="text/css" href="../styles/messages.css" />
<link rel="stylesheet" type="text/css" href="styles/tooleditor.css" />
<link rel="stylesheet" type="text/css" href="<%=request.getContextPath()%>/styles/formelement.css" />
<style>
input[type=button] 
{	
	font-family			:Verdana, Helvetica, Arial, sans-serif;
	font-size			:.8em;
	line-height			:10pt;
	font-weight			:normal;
	padding				:2px 2px 0px 2px;
	color				:#000033;
}
</style>

<script language="JavaScript" src="../scripts/ncw-i18n-js-support.jsp?resourcename=tooleditor"></script>
<script type="text/javascript" src="scripts/toolEditorControllers.js"></script>
<!-- APAR-IZ20892-Adding an external javascript file for setting the width of the list boxes based on the length of the items present.-->
<script type="text/javascript" src="../scripts/fixwidth.js"></script>
<script type="text/javascript" src="scripts/toolEditorValidators.jsp"></script>

<script type="text/javascript">
//<![CDATA[
var selectCtrl;

var sqlToolDefTabCtrl;
var accessTabCtrl;

var toggleCtrl;
var cgiFieldsDualList;

var groupDualList;
var classDualList;

var disabler;

var listPreselect;

var dirtyObserver;

/**
 * General compare function for dual-lists that is case-insensitive - for sorting in ascending order
 * TODO: I18N support
 *
 * @param optText0 (String) First String to compare.
 * @param optText1 (String) Second String to compare.
 * @return -1, 0, and 1 if optText0 is before, same as, and after optText1, respectively.
 */
function dualListCompareFunc( optText0, optText1 )
{
	var txt0 = optText0.toLowerCase();
	var txt1 = optText1.toLowerCase();

	if ( txt0 < txt1 ) return -1;
	else if ( txt0 > txt1 ) return 1;
	else return 0;
}

/** Initialise the editor. */
function init()
{
	dirtyObserver = new DirtyFormChecker( document.getElementById( "toolDefForm" ) );

	// Control the Tool definition to show depending on the type.
	selectCtrl = new SelectDivController( document.getElementById( "typeField" ) );
	selectCtrl.setClasses( ["", "hide"] );
	selectCtrl.registerOption( "SQL", "sqlToolDef" );
	selectCtrl.registerOption( "CGI/URL", "cgiToolDef" );
	selectCtrl.registerOption( "Command", "cmdToolDef" );
	selectCtrl.registerOption( "Script", "scriptToolDef" );

	// Control the SQL Tool tabs.
	sqlToolDefTabCtrl = new TabController();
	sqlToolDefTabCtrl.setClasses( ["selected", "", "content", "content hide"] );
	sqlToolDefTabCtrl.registerTab( "sqlTab", "sqlContent" );
	sqlToolDefTabCtrl.registerTab( "journalTab", "jrnlContent" );

	// Control the Access Criteria tabs.
	accessTabCtrl = new TabController();
	accessTabCtrl.setClasses( ["selected", "", "content", "content hide"] );
	accessTabCtrl.registerTab( "groupTab", "groupContent" );
	accessTabCtrl.registerTab( "classTab", "classContent" );

	// Control the toggling of CGI/URL fields.
	toggleCtrl = new ToggleController();
	toggleCtrl.addToggler( "cgiShowHide", new AttributeToggler( "cgiShowHide", "value", "<fmt:message key="toolDef.cgi.fields.button.hide.value" bundle="${langset}"/>" ) );
	toggleCtrl.addToggler( "cgiShowHide", new AttributeToggler( "cgiShowHide", "title", "<fmt:message key="toolDef.cgi.fields.button.hide.title" bundle="${langset}"/>" ) );
	toggleCtrl.addToggler( "cgiShowHide", new AttributeToggler( "cgiFields", "className", "" ) );

	// Control the CGI/URL fields dual-list.
	cgiFieldsDualList = new DualListController( "cgiFieldsAvailList", "cgiFieldsSelList" );
	cgiFieldsDualList.setDirtyObserver( dirtyObserver );
	cgiFieldsDualList.setButtons( ["cgiFieldsAdd", "cgiFieldsAddAll", "cgiFieldsRemove", "cgiFieldsRemoveAll"] );
	cgiFieldsDualList.setCompareFunction( dualListCompareFunc );

	// Control the Access Criteria Group dual-list.
	groupDualList = new DualListController( "groupAvailList", "groupSelList" );
	groupDualList.setDirtyObserver( dirtyObserver );
	groupDualList.setButtons( ["groupAdd", "groupAddAll", "groupRemove", "groupRemoveAll"] );
	groupDualList.addSelListToggler( new AttributeToggler( "groupTab", "style.fontStyle", "italic" ) );
	groupDualList.addSelListToggler( new AttributeToggler( "groupTab", "title", "<fmt:message key="access.group.tabdisabled.title" bundle="${langset}"/>" ) );
	groupDualList.setCompareFunction( dualListCompareFunc );

	// Control the Access Criteria Class dual-list.
	classDualList = new DualListController( "classAvailList", "classSelList" );
	classDualList.setDirtyObserver( dirtyObserver );
	classDualList.setButtons( ["classAdd", "classAddAll", "classRemove", "classRemoveAll"] );
	classDualList.addSelListToggler( new AttributeToggler( "classTab", "style.fontStyle", "italic" ) );
	classDualList.addSelListToggler( new AttributeToggler( "classTab", "title", "<fmt:message key="access.class.tabdisabled.title" bundle="${langset}"/>" ) );
	classDualList.setCompareFunction( dualListCompareFunc );

	disabler = new DisabledStatusController();
	disabler.registerComponent( "cgiNewWin", "cgiSpecWinName", false );
	disabler.registerComponent( "cgiSpecWin", "cgiSpecWinName", true );

	disabler.registerComponent( "cmdWinPlaf", "winCmd", true );
	disabler.registerComponent( "cmdSolPlaf", "solCmd", true );
	disabler.registerComponent( "cmdLinPlaf", "linCmd", true );
	disabler.registerComponent( "cmdHpuxPlaf", "hpuxCmd", true );
	disabler.registerComponent( "cmdAixPlaf", "aixCmd", true );

	listPreselect = new SubmitListPreselectController();
	listPreselect.addList( "groupAvailList" );
	listPreselect.addList( "groupSelList" );
	listPreselect.addList( "classAvailList" );
	listPreselect.addList( "classSelList" );
	listPreselect.addList( "cgiFieldsAvailList" );
	listPreselect.addList( "cgiFieldsSelList" );

	setUpValidation();

	initGUI();

	showServerErrors();
}

var validator;

/** Set up validation rules. */
function setUpValidation()
{
	// Control on-submit validation.
	validator = new ValidationController( "errors", "critical", "hide", "<fmt:message key="error.header" bundle="${langset}"/>" );

	validator.addRule( new ToolNameRule() );
	validator.addRule( new SQLCmdsRule() );
	validator.addRule( new JournalEntryRule() );
	validator.addRule( new CGIURLRule() );
	validator.addRule( new CGISpecWinRule() );
	validator.addRule( new CmdWinCmdRule() );
	validator.addRule( new CmdSolCmdRule() );
	validator.addRule( new CmdLinCmdRule() );
	validator.addRule( new CmdHPUXCmdRule() );
	validator.addRule( new CmdAIXCmdRule() );
	validator.addRule( new CmdPlatformRule() );
	validator.addRule( new ScriptCmdsRule() );
	
}

/** Initialise the editor GUI. */
function initGUI()
{
	// Show content as selected in the Type list.
	selectCtrl.showContent();

	groupDualList.initGUI();
	classDualList.initGUI();
	cgiFieldsDualList.initGUI();

	// Enable/disable CGI component Specific window field based on the radio button status.
	disabler.doDisable( "cgiSpecWin" );

	// Enable/disable Command component command fields based on the platform checkbox status.
	disabler.doDisable( "cmdWinPlaf" );
	disabler.doDisable( "cmdSolPlaf" );
	disabler.doDisable( "cmdLinPlaf" );
	disabler.doDisable( "cmdHpuxPlaf" );
	disabler.doDisable( "cmdAixPlaf" );

	document.getElementById( "nameField" ).focus();
}

/** Show server validation errors (if any) on the editor GUI. */
function showServerErrors()
{
	var serverErrors = getServerErrors();

	if ( serverErrors.length > 0 )
	{
		validator.injectServerErrors( serverErrors );
		validator.displayServerErrors();
	}
}

/**
 * Get the server validation errors. The elements in the returned array are generated by the server.
 *
 * @return (Array) ServerValidationError Objects.
 */
function getServerErrors()
{
	var serverErrors = new Array();

	<html:messages id="nameError" property="nameFieldLabel">
	serverErrors.push( new ServerValidationError( "nameFieldLabel", "<bean:write name="nameError"/>" ) );
	</html:messages>

	<html:messages id="sqlError" property="sqlCommandsLabel">
	serverErrors.push( new ServerValidationError( "sqlCommandsLabel", "<bean:write name="sqlError"/>" ) );
	</html:messages>

	<html:messages id="scriptError" property="scriptCommandsLabel">
	serverErrors.push( new ServerValidationError( "scriptCommandsLabel", "<bean:write name="scriptError"/>" ) );
	</html:messages>


	<html:messages id="jrnlError" property="jrnlEntryLabel">
	serverErrors.push( new ServerValidationError( "jrnlEntryLabel", "<bean:write name="jrnlError"/>" ) );
	</html:messages>

	<html:messages id="cgiUrlError" property="cgiUrlLabel">
	serverErrors.push( new ServerValidationError( "cgiUrlLabel", "<bean:write name="cgiUrlError"/>" ) );
	</html:messages>

	<html:messages id="winCmdError" property="winCmdLabel">
	serverErrors.push( new ServerValidationError( "winCmdLabel", "<bean:write name="winCmdError"/>" ) );
	</html:messages>

	<html:messages id="solCmdError" property="solCmdLabel">
	serverErrors.push( new ServerValidationError( "solCmdLabel", "<bean:write name="solCmdError"/>" ) );
	</html:messages>

	<html:messages id="linCmdError" property="linCmdLabel">
	serverErrors.push( new ServerValidationError( "linCmdLabel", "<bean:write name="linCmdError"/>" ) );
	</html:messages>

	<html:messages id="hpuxCmdError" property="hpuxCmdLabel">
	serverErrors.push( new ServerValidationError( "hpuxCmdLabel", "<bean:write name="hpuxCmdError"/>" ) );
	</html:messages>

	<html:messages id="aixCmdError" property="aixCmdLabel">
	serverErrors.push( new ServerValidationError( "aixCmdLabel", "<bean:write name="aixCmdError"/>" ) );
	</html:messages>

	return serverErrors;
}

/** Cancel editing. */
function doCancel()
{
	var toolListFrame = parent.toolListFrame;
	
	// To support pop-up Tool Editor, e.g., when access via the Menu Editor.
	if ( toolListFrame != undefined && toolListFrame != null )
	{
		window.location="<html:rewrite forward="toolGuide"/>";
	}
	else
	{
		close();
	}
}

/** Submit the form. */
function doSubmit()
{
	listPreselect.selectAll();
	document.getElementById( "toolDefForm" ).submit();
}

/**
 * Validate form data.
 *
 * @return True if no errors.
 */
function validate()
{
	return validator.validateAll();
}

/** Validate the form, then if no errors, submit it. */
function validateSubmit()
{
	var noError = validate();
	if ( !noError )
	{
		return false;
	}

	doSubmit();
}

/**
 * Prepare the editor to make a copy of a Tool.
 *
 * @param toolName (String) The name to use in the copy.
 */
function prepareToolCopy( toolName )
{
	var nameField = document.getElementById( "nameField" );

	nameField.value = getFormattedMessage( "name.copyof.value.javascript", toolName )
	document.getElementById( "nameFieldOrig" ).value = "";

	nameField.select();
}

/**
 * Check if the form is "dirty".
 *
 * @return True if dirty.
 */
function isDirty()
{
	return dirtyObserver.isDirty();
}

/** Get the Tool's name. */
function getToolName()
{
	return document.getElementById( "nameField" ).value;
}

//]]>
</script>
</head>

<body onload="init()">
<html:form action="/saveTool">

<div id="toolDetails">

<!-- All validation errors here. -->
<div id="message">
<div id="errors" class="hide"></div>
</div>

<table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr>
<div id="toolName">
		<td>
			<label id="nameFieldLabel" for="nameField"><fmt:message key="name.label" bundle="${langset}"/>
				<font color="red">*</font>
			</label>
		</td>
		<td>
			<html:text styleId="nameField" property="nameField" size="30" styleClass="textfield-required" />
		</td>
</div>
<html:hidden styleId="nameFieldOrig" property="nameFieldOrig" />
<div id="toolType">
		<td>
			<img src="../images/spacer.gif" height="40" width="65" alt="">
		</td>
		<td>
	<label for="typeField"><fmt:message key="type.label" bundle="${langset}"/></label>
		</td>
		<td> 
	<html:select styleId="typeField" property="typeField" onchange="selectCtrl.showContent()">
		<html:options property="toolTypes"/>
	</html:select>
		</td>
	</div>
</tr>
</table>

<!-- Tool Definition -->
<table border="0" width="100%">
	<tr>
		<td><p class="isc-section-header"><fmt:message key="toolDef.fieldset" bundle="${langset}"/></p></td>
	</tr>
</table>

	<!-- SQL -->
	<div id="sqlToolDef">
		<!-- Tabs -->
		<ul class="tabs">
			<li><a id="sqlTab" class="selected" title="<fmt:message key="toolDef.sql.tab.title" bundle="${langset}"/>" href="javascript:void(0)" onclick="sqlToolDefTabCtrl.showContent( this )"><fmt:message key="toolDef.sql.tab" bundle="${langset}"/></a></li>
			<li><a id="journalTab" title="<fmt:message key="toolDef.journal.tab.title" bundle="${langset}"/>" href="javascript:void(0)" onclick="sqlToolDefTabCtrl.showContent( this )"><fmt:message key="toolDef.journal.tab" bundle="${langset}"/></a></li>
		</ul>

		<div class="contentPane">
			<!-- SQL component -->
			<div id="sqlContent" class="content">
				<label id="sqlCommandsLabel" class="blockLabel" for="sqlCommands"><fmt:message key="toolDef.sql.commands.label" bundle="${langset}"/></label>
				<html:textarea styleId="sqlCommands" property="sqlCommands" rows="5" cols="55" />
				<br />
				<div class="contentGroup">
					<html:checkbox styleId="sqlExecForEach" styleClass="checkbox" property="sqlExecForEach" />
					<label class="checkboxLabel" for="sqlExecForEach"><fmt:message key="toolDef.sql.execforeach.label" bundle="${langset}"/></label>
				</div>
			</div>

			<!-- Journal component -->
			<div id="jrnlContent" class="content hide">
				<label id="jrnlEntryLabel" class="blockLabel" for="jrnlEntry"><fmt:message key="toolDef.journal.entry.label" bundle="${langset}"/></label>
				<html:textarea styleId="jrnlEntry" property="jrnlEntry" rows="5" cols="55" />
				<div class="contentGroup">
					<html:checkbox styleId="jrnlExecForEach" styleClass="checkbox" property="jrnlExecForEach" />
					<label for="jrnlExecForEach"><fmt:message key="toolDef.journal.execforeach.label" bundle="${langset}"/></label>
				</div>
			</div>
		</div>
	</div>

	<!-- CGI/URL -->
	<div id="cgiToolDef" class="hide">
		<!-- Tab -->
		<ul class="tabs">
			<li><a id="cgiTab" class="selected" title="<fmt:message key="toolDef.cgi.tab.title" bundle="${langset}"/>" href="javascript:void(0)"><fmt:message key="toolDef.cgi.tab" bundle="${langset}"/></a></li>
		</ul>

		<div class="contentPane">
			<!-- CGI/URL component -->
			<div id="cgiContent" class="content">
				<div class="contentGroup">
					<label id="cgiUrlLabel" class="cgiLabel" for="cgiUrl"><fmt:message key="toolDef.cgi.url.label" bundle="${langset}"/></label>
					<html:text styleId="cgiUrl" styleClass="cgiValue textfield-default" property="cgiUrl" />
					<div class="floatBreak"></div>
				</div>

				<!-- Fields -->
				<div class="contentGroup">
					<label class="cgiLabel" for="cgiShowHide"><fmt:message key="toolDef.cgi.fields.label" bundle="${langset}"/></label>
					<input id="cgiShowHide" title="<fmt:message key="toolDef.cgi.fields.button.show.title" bundle="${langset}"/>" type="button" onclick="toggleCtrl.toggleAll( this.id )" value="<fmt:message key="toolDef.cgi.fields.button.show.value" bundle="${langset}"/>" />

					<div id="cgiFields" class="hide">
						<div class="cgiFieldsLabelPadding">
							&nbsp;
						</div>
						<div id="cgiFieldsDualList">
							<!-- Labels -->
							<label class="cgiFieldsDualListLabel" for="cgiFieldsAvailList"><fmt:message key="toolDef.cgi.fields.availlist.label" bundle="${langset}"/></label>
							<div class="cgiFieldsDualListButtonsPad">&nbsp;</div>
							<label class="cgiFieldsDualListLabel" for="cgiFieldsSelList"><fmt:message key="toolDef.cgi.fields.sellist.label" bundle="${langset}"/></label>
							<br class="floatBreak" />

							<!-- Available list -->
							<html:select styleId="cgiFieldsAvailList" styleClass="cgiFieldsDualList" property="cgiFieldsAvailHilited" size="5" multiple="true">
								<html:options property="cgiFieldsAvail" />
							</html:select>

							<!-- Buttons -->
							<div class="cgiFieldsDualListButtons">
							<input id="cgiFieldsAddAll" type="button" value="&gt;&gt;" title="<fmt:message key="toolDef.cgi.fields.list.button.selectall.title" bundle="${langset}"/>" onclick="cgiFieldsDualList.addAllItems();" />
							<input id="cgiFieldsAdd" type="button" value="&gt;" title="<fmt:message key="toolDef.cgi.fields.list.button.selectone.title" bundle="${langset}"/>" onclick="cgiFieldsDualList.addItem();" />
							<input id="cgiFieldsRemove" type="button" value="&lt;" title="<fmt:message key="toolDef.cgi.fields.list.button.removeone.title" bundle="${langset}"/>" onclick="cgiFieldsDualList.removeItem();" />
							<input id="cgiFieldsRemoveAll" type="button" value="&lt;&lt;" title="<fmt:message key="toolDef.cgi.fields.list.button.removeall.title" bundle="${langset}"/>" onclick="cgiFieldsDualList.removeAllItems();" />
							</div>

							<!-- Selected list -->
							<html:select styleId="cgiFieldsSelList" styleClass="cgiFieldsDualList" property="cgiFieldsSelHilited" size="5" multiple="true">
								<html:options property="cgiFieldsSelected" />
							</html:select>
						</div>
						<div class="floatBreak"></div>
					</div>
				</div>

				<!-- Method -->
				<div class="contentGroup">
					<label class="cgiLabel"><fmt:message key="toolDef.cgi.method.label" bundle="${langset}"/></label>
					<html:radio styleId="cgiGet" property="cgiMethod" value="GET" />
					<label for="cgiGet"><fmt:message key="toolDef.cgi.method.get.label" bundle="${langset}"/></label>
					<br />
					<html:radio styleId="cgiPost" property="cgiMethod" value="POST" />
					<label for="cgiPost"><fmt:message key="toolDef.cgi.method.post.label" bundle="${langset}"/></label>
				</div>

				<!-- Open in -->
				<div class="contentGroup">
					<label class="cgiLabel"><fmt:message key="toolDef.cgi.openin.label" bundle="${langset}"/></label>
					<html:radio styleId="cgiNewWin" property="cgiOpen" value="cgiNewWin" onclick="disabler.doDisable( this.id )" />
					<label for="cgiNewWin"><fmt:message key="toolDef.cgi.openin.newwin.label" bundle="${langset}"/></label>
					<br />
					<html:radio styleId="cgiSpecWin" property="cgiOpen" value="cgiSpecWin" onclick="disabler.doDisable( this.id )" />
					<label id="cgiSpecWinNameLabel" for="cgiSpecWin"><fmt:message key="toolDef.cgi.openin.specwin.label" bundle="${langset}"/></label>

					<%-- html:text is not used here because it doesn't work with fmt:message. --%>
					<input id="cgiSpecWinName" name="cgiSpecWinName" title="<fmt:message key="toolDef.cgi.openin.specwin.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cgiSpecWinName}" />" />
				</div>
				<br class="floatBreak" />

				<!-- For each -->
				<div class="contentGroup">
					<html:checkbox styleId="cgiExecForEach" styleClass="checkbox" property="cgiExecForEach" />
					<label for="cgiExecForEach"><fmt:message key="toolDef.cgi.execforeach.label" bundle="${langset}"/></label>
					<br />
					<html:checkbox styleId="cgiWinForEach" styleClass="checkbox" property="cgiWinForEach" />
					<label for="cgiWinForEach"><fmt:message key="toolDef.cgi.winforeach.label" bundle="${langset}"/></label>
				</div>
			</div>
		</div>
	</div>

	<!-- Command Line -->
	<div id="cmdToolDef" class="hide">

		<!-- Tab -->
		<ul class="tabs">
			<li><a id="cmdTab" class="selected" title="<fmt:message key="toolDef.cmd.tab.title" bundle="${langset}"/>" href="javascript:void(0)"><fmt:message key="toolDef.cmd.tab" bundle="${langset}"/></a></li>
		</ul>


		<div class="contentPane">
			<div id="cmdContent" class="content">
				<!-- Category labels -->
				<div id="cmdPlafLabel" class="blockLabel"><fmt:message key="toolDef.cmd.platform.label" bundle="${langset}"/></div>
				<div id="cmdExecLabel" class="blockLabel"><fmt:message key="toolDef.cmd.execcmd.label" bundle="${langset}"/></div>
				<br class="floatBreak" />

				<!-- Windows -->
				<div class="cmdPlaf">
					<html:checkbox styleId="cmdWinPlaf" styleClass="checkbox" property="cmdWinPlaf" onclick="disabler.doDisable( this.id )" />
					<label id="winCmdLabel" for="cmdWinPlaf"><fmt:message key="toolDef.cmd.platform.win.label" bundle="${langset}"/></label>
				</div>

				<%-- html:text is not used here because it doesn't work with fmt:message. --%>
				<input id="winCmd" name="cmdWinCmd" class="textfield-default" size="50" title="<fmt:message key="toolDef.cmd.platform.win.execcmd.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cmdWinCmd}"/>" />

				<br class="floatBreak" />

				<!-- Solaris -->
				<div class="cmdPlaf">
					<html:checkbox styleId="cmdSolPlaf" styleClass="checkbox" property="cmdSolPlaf" onclick="disabler.doDisable( this.id )" />
					<label id="solCmdLabel" for="cmdSolPlaf"><fmt:message key="toolDef.cmd.platform.sol.label" bundle="${langset}"/></label>
				</div>

				<%-- html:text is not used here because it doesn't work with fmt:message. --%>
				<input id="solCmd" name="cmdSolCmd" class="textfield-default" size="50" title="<fmt:message key="toolDef.cmd.platform.sol.execcmd.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cmdSolCmd}"/>" />

				<br class="floatBreak" />

				<!-- Linux -->
				<div class="cmdPlaf">
					<html:checkbox styleId="cmdLinPlaf" styleClass="checkbox" property="cmdLinPlaf" onclick="disabler.doDisable( this.id )" />
					<label id="linCmdLabel" for="cmdLinPlaf"><fmt:message key="toolDef.cmd.platform.lin.label" bundle="${langset}"/></label>
				</div>

				<%-- html:text is not used here because it doesn't work with fmt:message. --%>
				<input id="linCmd" name="cmdLinCmd" class="textfield-default" size="50" title="<fmt:message key="toolDef.cmd.platform.lin.execcmd.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cmdLinCmd}"/>" />

				<br class="floatBreak" />

				<!-- HPUX -->
				<div class="cmdPlaf">
					<html:checkbox styleId="cmdHpuxPlaf" styleClass="checkbox" property="cmdHpuxPlaf" onclick="disabler.doDisable( this.id )" />
					<label id="hpuxCmdLabel" for="cmdHpuxPlaf"><fmt:message key="toolDef.cmd.platform.hpux.label" bundle="${langset}"/></label>
				</div>

				<%-- html:text is not used here because it doesn't work with fmt:message. --%>
				<input id="hpuxCmd" name="cmdHpuxCmd" class="textfield-default" size="50" title="<fmt:message key="toolDef.cmd.platform.hpux.execcmd.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cmdHpuxCmd}"/>" />

				<br class="floatBreak" />

				<!-- AIX -->
				<div class="cmdPlaf">
					<html:checkbox styleId="cmdAixPlaf" styleClass="checkbox" property="cmdAixPlaf" onclick="disabler.doDisable( this.id )" />
					<label id="aixCmdLabel" for="cmdAixPlaf"><fmt:message key="toolDef.cmd.platform.aix.label" bundle="${langset}"/></label>
				</div>

				<%-- html:text is not used here because it doesn't work with fmt:message. --%>
				<input id="aixCmd" name="cmdAixCmd" class="textfield-default" size="50" title="<fmt:message key="toolDef.cmd.platform.aix.execcmd.title" bundle="${langset}"/>" value="<c:out value="${toolDefForm.cmdAixCmd}"/>" />

				<div id="cmdContentGroup">
					<html:checkbox styleId="cmdExecForEach" styleClass="checkbox" property="cmdExecForEach" />
					<label class="checkboxLabel" for="cmdExecForEach"><fmt:message key="toolDef.cmd.execforeach.label" bundle="${langset}"/></label>
				</div>
			</div>
		</div>
	</div>
	
	
		<!-- Script -->
	<div id="scriptToolDef" class="hide">
		<!-- Tab -->
		<ul class="tabs">
			<li><a id="cmdTab" class="selected" title="<fmt:message key="toolDef.cmd.tab.title" bundle="${langset}"/>" href="javascript:void(0)"><fmt:message key="toolDef.cmd.tab" bundle="${langset}"/></a></li>
		</ul>


		<div class="contentPane">
			<div id="scriptContent" class="content">
				<label id="scriptCommandsLabel" class="blockLabel" for="scriptCommands"><fmt:message key="toolDef.script.commands.label" bundle="${langset}"/></label>
				<html:textarea styleId="scriptCommands" property="scriptCommands" rows="5" cols="55" />

				<div id="cmdContentGroup">
					<html:checkbox styleId="scriptExecForEach" styleClass="checkbox" property="scriptExecForEach" />
					<label class="checkboxLabel" for="scriptExecForEach"><fmt:message key="toolDef.script.execforeach.label" bundle="${langset}"/></label>
				</div>
			</div>
			
		</div>
				
	</div>

<!-- Access Criteria -->
<div class="formSection">

	<table border="0" width="100%">
		<tr>
			<td><p class="isc-section-header"><fmt:message key="access.fieldset" bundle="${langset}"/></p></td>
		</tr>
	</table>

	<!-- Tabs -->
	<ul class="tabs">
		<li><a href="javascript:void(0)" class="selected" id="groupTab" title="<fmt:message key="access.group.tab.title" bundle="${langset}"/>" onclick="accessTabCtrl.showContent( this )"><fmt:message key="access.group.tab" bundle="${langset}"/></a></li>
		<li><a href="javascript:void(0)" id="classTab" title="<fmt:message key="access.class.tab.title" bundle="${langset}"/>" onclick="accessTabCtrl.showContent( this )"><fmt:message key="access.class.tab" bundle="${langset}"/></a></li>
	</ul>


	<div class="contentPane">

		<!-- Group -->
		<div id="groupContent" class="content">
			<!-- Labels -->
			<label class="dualListLabel" for="groupAvailList"><fmt:message key="access.group.availlist.label" bundle="${langset}"/></label>
			<div class="dualListButtonsPad">&nbsp;</div>
			<label class="dualListLabel" for="groupSelList"><fmt:message key="access.group.sellist.label" bundle="${langset}"/></label>
			<br class="floatBreak" />

			<!-- Available list -->
			<html:select styleId="groupAvailList" styleClass="dualList" property="accessGroupsAvailHilited" size="10" multiple="true">
				<html:options property="accessGroupsAvail"/>
			</html:select>

			<!-- Buttons -->
			<div class="dualListButtons">
				<input id="groupAddAll" class="submitViaHrefCmdButton" type="button" value="&gt;&gt;" title="<fmt:message key="access.group.list.button.selectall.title" bundle="${langset}"/>" onclick="groupDualList.addAllItems();" />
				<input id="groupAdd" class="submitViaHrefCmdButton" type="button" value="&gt;" title="<fmt:message key="access.group.list.button.selectone.title" bundle="${langset}"/>" onclick="groupDualList.addItem();" />
				<input id="groupRemove" class="submitViaHrefCmdButton" type="button" value="&lt;" title="<fmt:message key="access.group.list.button.removeone.title" bundle="${langset}"/>" onclick="groupDualList.removeItem();" />
				<input id="groupRemoveAll" class="submitViaHrefCmdButton" type="button" value="&lt;&lt;" title="<fmt:message key="access.group.list.button.removeall.title" bundle="${langset}"/>" onclick="groupDualList.removeAllItems();" />
			</div>

			<!-- Selected list -->
			<html:select styleId="groupSelList" styleClass="dualList" property="accessGroupsSelHilited" size="10" multiple="true">
				<html:options property="accessGroupsSelected"/>
			</html:select>

			<!--
			Workaround for Firefox where the parent div does not increase in height together
			with the height of its content.
			-->
			<div style="clear:both;"></div>
		</div>

		<!-- Class -->
		<div id="classContent" class="content hide">
			<!-- Labels -->
			<label class="dualListLabel" for="classAvailList"><fmt:message key="access.class.availlist.label" bundle="${langset}"/></label>
			<div class="dualListButtonsPad">&nbsp;</div>
			<label class="dualListLabel" for="classSelList"><fmt:message key="access.class.sellist.label" bundle="${langset}"/></label>
			<br class="floatBreak" />

			<!-- Available list -->
			<!-- APAR:IZ22028-Introducing table attributes for the div to work appropriately for enabling scrolling-->
			<table>
			<tr>
			<td valign=top>
			<!-- APAR:IZ22028-Introducing div for the available lists for enabling scrolling based on the item length-->
			<div id="accessClassesAvailHilited" style="OVERFLOW: auto;WIDTH: 175px;HEIGHT: 175px" onscroll="OnDivScroll(document.getElementById('classAvailList'));" >
			<html:select styleId="classAvailList" styleClass="divList" property="accessClassesAvailHilited" size="10" multiple="true">			
				<html:optionsCollection property="accessClassesAvail" label="name" value="value" />
			</html:select>
	                    	</div>
		      	</td>


			<!-- Buttons -->
			<td valign=top>
			<div class="dualListButtons">
				<input id="classAddAll" class="submitViaHrefCmdButton" type="button" value="&gt;&gt;" title="<fmt:message key="access.class.list.button.selectall.title" bundle="${langset}"/>" onclick="classDualList.addAllItems();" />
				<input id="classAdd" class="submitViaHrefCmdButton" type="button" value="&gt;" title="<fmt:message key="access.class.list.button.selectone.title" bundle="${langset}"/>" onclick="classDualList.addItem();" />
				<input id="classRemove" class="submitViaHrefCmdButton" type="button" value="&lt;" title="<fmt:message key="access.class.list.button.removeone.title" bundle="${langset}"/>" onclick="classDualList.removeItem();" />
				<input id="classRemoveAll" class="submitViaHrefCmdButton" type="button" value="&lt;&lt;" title="<fmt:message key="access.class.list.button.removeall.title" bundle="${langset}"/>" onclick="classDualList.removeAllItems();" />
			</div>
			</td>

			<!-- Selected list -->
			<td>
			<!-- APAR:IZ22028-Introducing div for the selected lists for enabling scrolling based on the item length-->
			<div id="accessClassesSellHilited" style="OVERFLOW: auto;WIDTH: 175px;HEIGHT: 175px"  onscroll="OnDivScroll(document.getElementById('classSelList'));" >
			<html:select styleId="classSelList" styleClass="divList" property="accessClassesSelHilited" size="10" multiple="true">
				<html:optionsCollection property="accessClassesSelected" label="name" value="value" />
			</html:select>
			</div>
			</td>
			<div class="floatBreak"></div>
			</tr>
			</table>
		</div>
	</div>

</div>

<br><div class="isc-section-header"></div>

<div id="saveButtons">
	<table border="0" width="100%">
		<tr>
			<td align="left">
				<button id="saveButton" type="button" onclick="validateSubmit()"><fmt:message key="save.button.value" bundle="${langset}"/></button>
				<button id="cancelButton" type="button" onclick="doCancel()"><fmt:message key="cancel.button.value" bundle="${langset}"/></button>
			</td>
		</tr>
	</table>	
</div>

<br class="floatBreak" />

</div>

</html:form>

</body>
</html:html>
