if(!dojo._hasResource["com.ibm.isclite.dijit.custom.events.EventsTable"]){ 
dojo._hasResource["com.ibm.isclite.dijit.custom.events.EventsTable"] = true;
//public package
dojo.provide("com.ibm.isclite.dijit.custom.events.EventsTable");

// dojo require
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.isclite.dijit.Tree"); 
dojo.require("com.ibm.isclite.dnd.Source"); 


//com.ibm.isclite.dijit.custom.events.EventsTable
dojo.declare(
	"com.ibm.isclite.dijit.custom.events.EventsTable",
	[dijit._Widget, dijit._Templated],
{
    templateString: "<table class='eventsTable'>\n\t"+
                        "<thead class='eventsTableThead'>\n\t\t"+
                            "<tr class='isc-table-header'><th class='isc-table-header-data' style='padding-right:20px;'>${enableTitle}</th><th class='isc-table-header-data' style='padding-right:20px;'>${eventTitle}</th></tr>\n\t"+
                        "</thead>\n\t"+
                        "<tbody class='eventsTableTbody' dojoAttachPoint=\"body\">\n\t\t"+
                            "<tr class='eventsTableTr availableTargetTd' dojoAttachPoint=\"row\">\n\t\t\t"+
                                "<td class='eventsTableChekBoxTd'  >\n\t\t\t"+
                                "</td>\n\t\t\t"+
                                "<td class='eventsTableTreeTd' style='font-size:13px;'>\n\t\t\t"+
                                "</td>\n\t\t"+
                            "</tr>\n\t"+
                            "<tr>"+
                            "<td colspan='2' style='width:100px;padding-left:10px;font-family:verdana;font-size:13px;' dojoAttachPoint=\"textNode\" >"+
                                    "There are no events"+
                                "</td>"+
                            "</tr>"+     
                        "</tbody>\n"+
                    "</table>",
                    
    store: null,
    enableTitle:"",
    eventTitle:"",
    _controller:null,
    uniquePageName:"",
    parentId:"",
    label:"There are no Published/Subscribed events",
   
    postCreate: function(){
        //create controler for table
        this._controller = new com.ibm.isclite.dijit.custom.events._EventsTableController({ _table:this});
        this._publish("afterEventsTableCreate");
    },
    
    //update checkbox
    updateRow: function(/*dijit.form.CheckBox*/checkBox){
        var item = checkBox.item;
        var enable = this.store.getValue(item, "enable")||false;
        checkBox.setChecked(enable);
    },
    
    setLabel:function(){
     var text= this.label;
     var tr = this.textNode.cloneNode(true);
     this.body.appendChild(tr);
     this.textNode.appendChild(document.createTextNode(text));
   
    },
    //add row to the table
    addRow: function(/*Object*/item){
        //clone template row
        var tr = this.row.cloneNode(true);

        var cells = [];
        dojo.query("td", tr).forEach(function(cell){
            cells.push(cell);
        });
        
        //create checkbox
        var checkBoxCell = cells[0];
        var checkBox = this._createCheckBox(item,checkBoxCell);
        
        //create Tree
        var treeCell = cells[1];
        var tree = this._createTree(item,treeCell);
        //append new row in the table
        this.body.appendChild(tr);
        return {checkBox:checkBox,tree:tree};
        
    },
    
    //create checkbox widget 
    _createCheckBox : function (/*Object*/item,/*DOM node*/checkBoxCell){
        //create dummy dom element and attach it to check box td
        var chekBoxRefNode = document.createElement("span");
        checkBoxCell.appendChild(chekBoxRefNode);
        
        var itemId = this.store.getIdentity(item);
        var checkBoxId=this.id+"_"+itemId+"_enableCheckBox";
        var enable = this.store.getValue(item, "enable")||false;
        var checkBox = new com.ibm.isclite.dijit.custom.events.EventsTable._CheckBox( { id:checkBoxId,type:"checkbox",checked:enable,item:item,table:this},chekBoxRefNode);
		checkBox.setDisabled(this.store.getValue(item,"direction")=="subscribe");
        checkBox.startup();
        return checkBox;
    
    },
    
    //create tree widget 
     _createTree : function (/*Object*/item,/*DOM node*/treeCell){
       
        var itemId = this.store.getIdentity(item);
        var itemLabel = this.store.getValue(item, "name");

		var eventDragSourceRefNode = document.createElement("span");
		treeCell.appendChild(eventDragSourceRefNode);

		var treeRefNode = document.createElement("span");

	    var treeId=this.id+"_"+itemId+"_paramTree";
	    var tree = new com.ibm.isclite.dijit.custom.events.EventsTable._Tree( {store:this.store,labelAttr:"name",query:{type:'event',id:itemId},id:treeId,childrenAttr:["params"],tableId:this.id}, treeRefNode);
		
		var self = this;
	
		
		
		var sourceEventNodeCreatorInit = function(data, hint){
			var types = ["eventItem"];
			var node = dojo.doc.createElement("div");
			node.id = dojo.dnd.getUniqueId();
			node.appendChild(tree.domNode);
			return {node: node, data: data, type: types};
		};
		
		var sourceEventNodeCreator = function(data, hint){
		
			var types = ["eventItem"];
			var node = dojo.doc.createElement("div");
			node.id = dojo.dnd.getUniqueId();
			node.innerHTML = data.wireSource.name;
			return {node: node, data: data, type: types};
		};
        
                
		var wireSource = {
			wireSourcePortletTitle:this.store.getValue(item, "wireSourcePortletTitle"),
			sourceEventName:this.store.getValue(item, "sourceEventName"),
			pii:this.store.getValue(item, "pii"),
			navigationElementRef:this.store.getValue(item, "navigationElementRef"),
            uniquePageName:this.uniquePageName,
			windowElementRef:this.store.getValue(item, "windowElementRef"),
			name:this.store.getValue(item, "name")
		};
		var context = {wireSource: wireSource};
              
	       var isSource=true;
			if(item.direction[0]=="subscribe"){
				isSource=false;
			}
	
		var eventDragSource = new com.ibm.isclite.dnd.Source(eventDragSourceRefNode, {creator: sourceEventNodeCreatorInit, accept: [], horizontal: false, copyOnly: true,isSource:isSource});
		eventDragSource.insertNodes(false, [context]); 
		tree.startup();

		eventDragSource.creator = sourceEventNodeCreator; 
     },
    
    //apply different class for odd rows
    applyOddClass: function(){
        dojo.query("tr:nth-child(odd)", this.body).addClass("eventsTableOddRow");
        dojo.query("tr:nth-child(even)", this.body).removeClass("eventsTableOddRow");
    },
    
    //remove template row
    _removeTemplateRow : function (){
        dojo.query("tr",this.body).orphan();
    },
    
    //Publish a message for this widget/topic
    _publish: function(/*String*/ topicName, /*Object*/ message){
		dojo.publish(this.id, [dojo.mixin({table: this, event: topicName}, message||{})]);
	},
    
    //clean resources
    destroy: function(){
        //TODO: clean
		// publish destruction event so that any listeners should stop listening
		this._publish("beforeEventsTableDestroy");
        this.query =null;
        this.store=null;
        this._controller=null;
        return this.inherited('destroy', arguments);
	}
    
});//com.ibm.isclite.dijit.custom.events.EventsTable



//com.ibm.isclite.dijit.custom.events._EventsTableController
dojo.declare(
	"com.ibm.isclite.dijit.custom.events._EventsTableController",
	[dijit._Widget],
{
    _table:null,
    _itemChekBoxMap:null,
    _subscription:null, 
    _selectedTree:null,
    
    //connect
    postMixInProperties: function(){
        this._itemChekBoxMap = {};
		// setup to handle events from tree
        this.connect(this._table.store, "onSet","onUpdateItem");
        
        
        this._subscription=dojo.subscribe(this._table.id, this, "_listener");
		
	},
    
    _listener: function(/*Object*/ message){
    
		// summary: dispatcher to handle events from tree
		var event = message.event;
		var eventHandler =  "on" + event.charAt(0).toUpperCase() + event.substr(1);
		if(this[eventHandler]){
			this[eventHandler](message);
		}
	},
    
    onBeforeEventsTableDestroy: function(/*Object*/ message){
		//dojo.unsubscribe(message.table.id);
        this.destroy();
	},
    //store set
    onUpdateItem: function(/*Object*/ message){
		//summary: set data event  on an item in the store
		var itemId = this._table.store.getIdentity(message);
        var checkBox = this._itemChekBoxMap[itemId];
        if(checkBox){
            this._table.updateRow(checkBox);
        }
        
	},
    
    onAfterEventsTableCreate: function(/*Object*/ message){
		//fetch from store
        this._runQuery();
	},
    
    //tree node execute
    onSelectTreeNode: function(/*Object*/ message){
		// summary: an execute event has occured
        var selectedTree = message.tree;
		if(this._selectedTree){
            var oldId = this._selectedTree.id;
            var newId = selectedTree.id;
            if(oldId != newId){
                this._selectedTree.clearSelection();
                this._selectedTree=selectedTree;
            }
        }else{
            this._selectedTree=selectedTree;
        }
        var parentId = this._table.parentId;
        dojo.publish(parentId, [dojo.mixin({item:message.node.item, event: "selectTreeNode"}, {})]);
        

	},
    
    //fetch from store
    _runQuery: function(){
        var self = this;
        //console.log('this._table.store',this._table.store);
        //console.log('this._table.query',this._table.query);
        function onComplete(/*dojo.data.Item[]*/ items){
            
           self._table._removeTemplateRow();
           //add rows
        
           if(items.length==0){
              self._setLabel();
           }else{ 
           for(i in items){
              self._addRow(items[i]);
           } }
           //apply odd style
           self._table.applyOddClass();
		};
        this._table.store.fetch({query:this._table.query, onComplete: onComplete});
    },
    
    _addRow: function(/*Object*/ item){
        var row = this._table.addRow(item);
        var itemId = this._table.store.getIdentity(item);
        this._itemChekBoxMap[itemId]=row.checkBox;
    },
     _setLabel: function(){
         var row = this._table.setLabel();
        
    },
    
    destroy: function(){

		this._table=null;
        this._selectedTree=null;
        this._itemChekBoxMap=null;
        dojo.unsubscribe(this._subscription);
        this._subscription = null;
        return this.inherited('destroy', arguments);

	}

});//com.ibm.isclite.dijit.custom.events._EventsTableController

//com.ibm.isclite.dijit.custom.events.EventsTable._CheckBox
dojo.declare(
    "com.ibm.isclite.dijit.custom.events.EventsTable._CheckBox",
	dijit.form.CheckBox,
{
    table:null,
    item:null,
    //onclick
    onClick: function(/*Event*/ evt){
       this.table.store.setValue(this.item,  "enable", this.checked);
       this.table.store.setValue(this.item,  "enableWire", this.checked);
	},

    destroy: function(){
		this.table=null;
        this.item=null;
        return this.inherited('destroy', arguments);
		//return dijit._Widget.prototype.destroy.apply(this, arguments);
	}
});//com.ibm.isclite.dijit.custom.events.EventsTable._CheckBox


//com.ibm.isclite.dijit.custom.events.EventsTable._Tree
dojo.declare(
    "com.ibm.isclite.dijit.custom.events.EventsTable._Tree",
	com.ibm.isclite.dijit.Tree,
{
    tableId:"",

    onClick: function(/* dojo.data */ item, /*TreeNode*/ node){
		dojo.publish(this.tableId, [dojo.mixin({tree: this,node:node, event: "selectTreeNode"}, {})]);
	}
    

});//com.ibm.isclite.dijit.custom.events.EventsTable._Tree



}//has resource