/* customizer javascript */

// TODO:  handle errors in AJAX, etc
dojo.registerModulePath("com","../com");
dojo.require("dojo.dnd.Source"); // capital-S Source in 1.0
dojo.require("dojo.parser");  


var customizer = {
	tempResizeStore: {},
	pagesInCustomMode : [],
	piiContainerArray : [],
	reloadStoreData: false ,
	maximizedPortlets: [],
	restoredPortlet: null,
	getAncestors: function(/*Node*/node, /*function?*/filterFunction, /*boolean?*/returnFirstHit){
		//  summary:  (abandoned by dojo 0.9.0)
		//      returns all ancestors matching optional filterFunction; will return
		//      only the first if returnFirstHit
		var ancestors = [];
		var isFunction = (filterFunction && (filterFunction instanceof Function || typeof filterFunction == "function"));
		while(node){
			if(!isFunction || filterFunction(node)){
				ancestors.push(node);
			}
			if(returnFirstHit && ancestors.length > 0){
				return ancestors[0];    //  Node
			}
			node = node.parentNode;
		}
		if(returnFirstHit){ return null; }
		return ancestors;   //  array
	},
	getAncestorsByTag: function(/*Node*/node, /*String*/tag, /*boolean?*/returnFirstHit){
		//  summary: (abandoned by dojo 0.9.0)
		//      returns all ancestors matching tag (as tagName), will only return
		//      first one if returnFirstHit
		tag = tag.toLowerCase();
		return customizer.getAncestors(node, function(el){
			return ((el.tagName)&&(el.tagName.toLowerCase() == tag));
		}, returnFirstHit); //  Node || array
	},
	getFirstAncestorByTag: function(/*Node*/node, /*string*/tag){
		//  summary:  (abandoned by dojo 0.9.0)
		//      Returns first ancestor of node with tag tagName
		return customizer.getAncestorsByTag(node, tag, true); //  Node
	},
	getPreviousSiblingElement: function(/* Node */node, /* string? */tagName){
		//  summary: (abandoned by dojo 0.9.0)
		//      returns the previous sibling element matching tagName
		if(!node) { return null; }
		if(tagName) { tagName = tagName.toLowerCase(); }
		do {
			node = node.previousSibling;
		} while(node && node.nodeType != 1);
		if(node && tagName && tagName.toLowerCase() != node.tagName.toLowerCase()) {
			return customizer.getPreviousSiblingElement(node, tagName);
		}
		return node;    //  Element
	},
	replaceNode: function(/*Element*/node, /*Element*/newNode){
    	//  summary:  (abandoned by dojo 0.9.0)
    	//      replaces node with newNode and returns a reference to the removed node.
    	//      To prevent IE memory leak, call destroyNode on the returned node when
    	//      it is no longer needed.
    	return node.parentNode.replaceChild(newNode, node); // Node
	},
	getNextSiblingElement: function(/* Node */node, /* string? */tagName){
		//  summary:  (abandoned by dojo 0.9.0)
		//      returns the next sibling element matching tagName
		if(!node) { return null; }
		do {
			node = node.nextSibling;
		} while(node && node.nodeType != 1);
		if(node && tagName && tagName.toLowerCase() != node.tagName.toLowerCase()) {
			return customizer.getNextSiblingElement(node, tagName);
		}
		return node;    //  Element
	},
    
	showTable:function(uniquePageName){
		var buttonId = uniquePageName +"_wires_button_id";
		var wireButton = dojo.byId(buttonId);
		dojo.addClass(wireButton,'isc-table-toolbar-buttonbar-hide');

		var div = dijit.byId(uniquePageName+"_Wires_Table_ID").domNode;
		expandTable= function(/*Object*/ args){
			// summary
			//		Returns an animation that will expand the
			//		node defined in 'args' object from it's current height to
			//		it's natural height (with no scrollbar).
			//		Node must have no margin/border/padding.
			args.node = dojo.byId(args.node);
			var node = args.node, s = node.style;

			var anim = dojo.animateProperty(dojo.mixin({
				properties: {
					height: {
						// wrapped in functions so we wait till the last second to query (in case value has changed)
						start: function(){
							// start at current [computed] height, but use 1px rather than 0
							// because 0 causes IE to display the whole panel
							s.overflow="hidden";
							if(s.visibility=="hidden"||s.display=="none"){
								s.height="1px";
								s.display="";
								s.visibility="";
								return 1;
							}else{
								var height = dojo.style(node, "height");
								return Math.max(height, 1);
							}
						},
						end: function(){
							return node.scrollHeight;
						}
					}
				}
			}, args));
			dojo.connect(anim, "onEnd", function(){ 
				s.height = "auto";
				s.overflow="";
				// resize page contents once the animation is finished
				var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
				customizer.rescaleRelativePage( pageDiv );
				if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'show wires table' );
			});
			return anim; // dojo._Animation
		}	
		expandTable({ node: div, left:"0", top:"50", unit:"px" }).play(); 
     },
    
    destroyWireTable:function(uniquePageName){
	   var table = dijit.byId(uniquePageName+"_Wires_Table_ID");
	   
	   
       if(table){
           table.destroy();
       }
    },
    
    setupWiresTable:function(pageDiv){
        
        var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );

        var uniquePageName = pageDataObject.uniquePageName;
	this.destroyWireTable(uniquePageName);
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = dijit.byId(storeManagerId);
		var store = storeManager.getWiresStore();
        var tableId = uniquePageName+"_Wires_Table_ID";
        var table = dijit.byId(tableId);
        
		var tableParent = dojo.byId(pageDataObject.uid+ "_wires_table_id");
         
       // if(table == null){
			var nodeRef = document.createElement("div");
			tableParent.appendChild(nodeRef);
            table = new com.ibm.isclite.dijit.custom.wires.WiresTable( {
                wireTypeTableLabel               :eventsAndWiresNls.wiresTable.wireTypeLabel,
                sourceLabel                 :eventsAndWiresNls.wiresTable.sourceLabel,
                eventLabel                  :eventsAndWiresNls.wiresTable.eventLabel,
                targetLabel                 :eventsAndWiresNls.wiresTable.targetLabel,
                transformLabel              :eventsAndWiresNls.wiresTable.transformLabel,
                enableLabel                 :eventsAndWiresNls.wiresTable.enableLabel,
                deletedLabel                :eventsAndWiresNls.wiresTable.deletedLabel,
                noTransformLabel            :eventsAndWiresNls.wiresTable.noTransformationLabel,
                wiresTableDescriptionLabel  :eventsAndWiresNls.wiresTable.wiresTableDescriptionLabel,
                newLabel                    :eventsAndWiresNls.wiresTable.newLabel,
                wiresTableTitlelabel        :eventsAndWiresNls.wiresTable.wiresTableTitlelabel,
                closeLabel                  :eventsAndWiresNls.wiresTable.closeLabel,
                totalLabel                  :eventsAndWiresNls.wiresTable.totalLabel,
                targetButtonTitle           :eventsAndWiresNls.wiresTable.targetButtonTitle,
                transformationButtonTitle   :eventsAndWiresNls.wiresTable.transformationButtonTitle,
                deleteTitle                 :eventsAndWiresNls.wiresTable.deleteTitle,
                enableTitle                 :eventsAndWiresNls.wiresTable.enableTitle,
		wireTypeCustom          :eventsAndWiresNls.wiresTable.wireTypeCustom,
		wireTypeSystem         :eventsAndWiresNls.wiresTable.wireTypeSystem,
                
                store                       :store,
                labelAttr                   :"name",
                uniquePageName              :uniquePageName,
                storeManager                :storeManager,
                query                       :{type:'wire'},
                id                          :tableId,childrenAttr:"params"},
                nodeRef);
      //  }
	
	
	
	/*if(tableParent!=table.domNode.parentNode){
		
			var oldTableParent = table.domNode.parentNode;
			oldTableParent.removeChild(table.domNode);
            tableParent.appendChild(table.domNode); 
		
	
	}	*/
	
        table.domNode.style.display="none";
	
	
    },
	enterResizeMode: function( pageDiv ) {
		// enter resize-only mode
		customizer.displaySizers( pageDiv );
		// initialize relative sizes and do initial scaling
		customizer.makePageRelative( pageDiv ); // HERE
		if ( customizer.tempResizeStore[pageDiv.modelObject.pageData.uid] ) {
			// restore temp sizings that where not saved
			customizer.restorePortletSizes( pageDiv, customizer.tempResizeStore[pageDiv.modelObject.pageData.uid] );
		}
	},
	restorePortletSizes: function( pageDiv, sizeObject ) {
		var portlets = dojo.query( 'table[name="IscPortlet"]', pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			var pii = portlets[i].modelObject.portletData.basePii;
			if ( sizeObject[pii] ) {
				portlets[i].parentNode.style.width = sizeObject[pii][0] + "px";
				portlets[i].parentNode.style.height = sizeObject[pii][1] + "px";
			}
		}
	},
	setTempResizeStore: function( pageId, pii, width, height ) {
		if ( ! customizer.tempResizeStore[pageId] ) customizer.tempResizeStore[pageId] = {};
		customizer.tempResizeStore[pageId][pii] = [ width, height ];
	},
	displaySizers: function( pageDiv ) {
		var layoutRoot = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if ( typeof layoutRoot == 'undefined' || !layoutRoot ) {
			console.error( "error: layout root not found" );
			return;
		}
		// find, attach event handler, and display sizer bars
		dojo.query( 'td[class^="isc-layout-sizebar-"]', layoutRoot ).forEach(
			function( i ) {
				dojo.style( i, 'visibility', 'visible' );
				if ( ! i.event ) {
					i.event = dojo.connect( i, "onmousedown", customizer, "sizeMouseDown" );
				}
			}
		);
	},
	enterCustomizeModeFromMenu: function( pageDiv ) {
		// this is called from the taskbar dropdown "Edit Page.." entry
		// alerts the server that the page is to be customized and
		// calls enterCustomizeMode()
		var uid = pageDiv.modelObject.pageData.tid;
		var url = '/ibm/console/customizer.do?action=edit'
					+ '&moduleRef=' + pageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + pageDiv.modelObject.pageData.uniquePageName
					+ '&windowId=' + '000' // there's no specific window, but we have to send something
					+ '&edit=true';
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );
		pageDiv.modelObject.setPageInEditMode( true );
		customizer.enterCustomizeMode( pageDiv );
		
	},
	enterSaveAsFromMenu:function(pageDiv){
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
		eval( 'var pageDataObject = ' + pageData );
		var uniquePageName = pageDataObject.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		
		var storeManager = dijit.byId(storeManagerId); 
		if (storeManager){
			eventsAndWiresUW = storeManager.getUnitOfWork("ISC.saveAsPage");
        }
		var eventsAndWiresArray = new Array();
		eventsAndWiresArray["eventsAndWiresUW"] = dojo.toJson(eventsAndWiresUW);
		var content=eventsAndWiresArray;
		var location = '/ibm/console/taskbarfragment.do?ISC.saveAsPage='+pageDiv.modelObject.pageData.uid;
		SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
	},
	enterCustomizeMode: function( pageDiv ) {
		// puts the page visuals into customize mode
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;
		pageDiv.modelObject.pageData.noSize = false;

		// If the page is already showing edit mode, do nothing
		if( pageDiv.modelObject.isPageShowingEditMode() ) return;

		pageDiv.modelObject.setPageShowingEditMode( true );
		customizer.displaySizers( pageDiv );
		// toggle display of save/cancel buttons for this page
		dojo.query( 'td.isc-table-toolbar-buttonbar-hide', pageDiv ).forEach(
			function( i ) {
				dojo.removeClass( i, 'isc-table-toolbar-buttonbar-hide' );
				dojo.addClass( i, 'isc-table-toolbar-buttonbar' );
			}
		);
		// toggle display of wires buttons for this page
		dojo.query( 'input.isc-table-toolbar-buttonbar-hide', pageDiv ).forEach(
			function( i ) {
				dojo.removeClass( i, 'isc-table-toolbar-buttonbar-hide' );
				dojo.addClass( i, 'isc-table-toolbar-buttonbar' );
			}
		);	

		// initialize sizing just in case it isn't
		if ( ! pageDiv.modelObject.pageData.percentsSet ) {
			customizer.makePageRelative( pageDiv );
		} else {
			// audit portlet sizes and notify portlets
			if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer.enterCustomizeMode()' );
		}

		// toggle display of items in dropdown menu
		// there is an IE bug (since 2003) that stops this working in all versions of IE
		// see:   http://codylindley.com/Webdev/315/ie-hiding-option-elements-with-css-and-dealing-with-innerhtml
		//        http://support.microsoft.com/default.aspx?scid=kb;en-us;276228
		// rather than mucking around in the DOM, for now, leaving it...
		var dropDownMenu = null;
		if (parent.taskbar.dojo != null) {
			parent.taskbar.dojo.byId( 'PageAction' );
		}
		if (dropDownMenu != null) {
			dropDownMenu.selectedIndex = 0;
			for ( var i=0; i<dropDownMenu.options.length; i++ ) {
				if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-hide' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-show';
				} else if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-show' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-hide';
				}
			}
		}
		this.initEventsAndWiresClasses();
		this.setupEventsAndWiresStoreManager(pageDiv);
		this.setupWiresDragAndDrop( pageDiv );
		this.setupWiresTable(pageDiv);
		this.setupEventsAndWiresController(pageDiv);
		this.reloadStoreData=false;
		var portlets = UIElement.getElementsByName( pageDiv, "PortletFragment" );
		for ( var i=0; i<portlets.length; i++ ) {
			this.setupPorltetWiresDragAndDrop( portlets[i] );		
			customizer.putPortletInCustomizeMode( portlets[i] );
		}

		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
        var uniquePageName = pageDataObject.uniquePageName;
		var count = this.pagesInCustomMode[uniquePageName];
		if(!count){
			count = 0;
		}
		count++;
		this.pagesInCustomMode[uniquePageName] = count;
		
		this.manageSaveButtonState(pageDiv);
	},
    
	/*
	*	Enables/disables the Customizer save button, depending on PP presence on the page
	* 	pageDiv - the page div where the button resides, if it is not passed the method tries to retrieve it for the current page
	*/	
	manageSaveButtonState: function(pageDiv)
	{
		if(pageDiv == null)
		{
			pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		}
		
		var pickers = dojo.query( 'div[name="thepicker"]', pageDiv );		
		if(pickers.length > 0)
		{
			this.disableSaveButton(true, pageDiv);
		}
		else
		{
			this.disableSaveButton(false, pageDiv);		
		}
	},	
	
	/*
	*	Disables the Customizer save button
	* 	pageDiv - the page div where the button resides, if it is not passed the method tries to retrieve it for the current page
	*	value - true - disables the button, false - enables the button
	*/
	disableSaveButton: function(value, pageDiv)
	{
		if(pageDiv == null)
		{
			pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		}	
		
		var saveBtn = dojo.query( 'input[name="page.titlebar.save"]', pageDiv );
		if(saveBtn.length > 0)
		{
			saveBtn[0].disabled = value;
		}
	},	
	
    initEventsAndWiresClasses: function(){
        dojo.require("com.ibm.isclite.dijit.custom.wires.WiresTable");   
        dojo.require("dojo.data.ItemFileWriteStore");
        dojo.require("dijit.dijit");
        dojo.require("dojo.fx");
        dojo.require("com.ibm.isclite.data.custom.eventsandwires.StoreManager");
        dojo.require("com.ibm.isclite.dijit.custom.events.Events");
        dojo.require("com.ibm.isclite.data.custom.eventsandwires.Controller");
        //dojo.require("com.ibm.isclite.dnd.Target");
        dojo.require("com.ibm.isclite.data.custom.eventsandwires.WireDNDManager");
        
    },
    
	putPortletInCustomizeMode: function( portletDiv ) {
		var iscPortletDiv = dojo.query( 'table[name="IscPortlet"]', portletDiv );
		var portletData = iscPortletDiv[0].getAttribute( 'portletdataobject' );
		eval( 'var pageDataObject = ' + portletData );
		var basePii=pageDataObject.basePii;
	
		// event bubbling in FF causes mouseover for drop targets to not work
		// unless I just use the span instead of the table or TDs to listen
		// attach event handler for drag and drop
		if ( portletDiv.tagName.toLowerCase() != 'div' ) {
			console.debug( 'yikes! expecting a DIV in customizer.putPortletInCustomizeMode() but got a ' + portletDiv.tagName );
			return;
		}
		var header = dojo.query( 'table[name="portletHeaderTable"]', portletDiv )[0];
		if ( header === undefined ) return; // nothing here to work on...
		var span = dojo.query( 'span', header )[0];
		dojo.style( span, 'cursor', 'move' );
		if ( ! span.event ) {
			span.event = dojo.connect( span, "onmousedown", customizer, "dndMouseDown" );
		}
		var ppDiv = dojo.query("div[name='thepicker']",portletDiv);
		
		var isPP = false;
		if(ppDiv.length > 0)
		{
			isPP = true;
		}
		if ( ! isPP && ! portletDiv.sizeSent ) {
			// if this portlet's size isn't saved, save it - unless it's the portlet picker
			customizer.sendPortletSize( portletDiv );
		}
		
		// unhide any empty window titlebars...
        var titlebar = dojo.query( 'td.isc-portlet-titlebar', portletDiv )[0];
        titlebar.style.visibility = '';
        		
		customizer.togglePortletTitleButtons( header ,basePii, isPP);
	},
	showEmptyWindows: function( pageDiv ) {
        // show empty windows (except titlebar) on sized pages
        // needed in any non-nosize page to make sizing work
        if ( pageDiv.modelObject.isNoSizePage() ) return;
        var windows = dojo.query( 'td[name="emptyWindowToShow"]', pageDiv );
        for ( var i=0;i<windows.length;i++ ) {
            windows[i].style.display = '';
            windows[i].style.visibility = '';
            windows[i].style.opacity = '';
            var titlebar = dojo.query( 'td.isc-portlet-titlebar', windows[i] )[0];
           	titlebar.style.visibility = 'hidden';
        }
    },
	setupEventsAndWiresStoreManager: function(pageDiv){
		// creates the Event Wires and Target stores
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
        var moduleRef = pageDataObject.moduleRef;
        var uniquePageName = pageDataObject.uniquePageName;
		var id = uniquePageName+"_store_id";
		
		if(this.reloadStoreData)
		{
			this.destroyStoreManager(uniquePageName);
		}
		if(!dijit.byId(id)){
		
			new com.ibm.isclite.data.custom.eventsandwires.StoreManager(moduleRef, uniquePageName,id);
		}
	},
    
    setupEventsAndWiresController: function(pageDiv){
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
        var moduleRef = pageDataObject.moduleRef;
        var uniquePageName = pageDataObject.uniquePageName;
        
        
		var id = uniquePageName+"_controller_id";
		if(this.reloadStoreData)
		{
			this.destroyController(uniquePageName);
		}
		
		if(!dijit.byId(id)){
            var controller = new com.ibm.isclite.data.custom.eventsandwires.Controller(uniquePageName,id);
			//new com.ibm.isclite.data.custom.eventsandwires.StoreManager(moduleRef, uniquePageName,id);
            //controller.dispatcher("","newWire");
		}
	},
    
    controllerDispatch: function(uniquePageName,context,action){
        var id = uniquePageName+"_controller_id";
        var controller = dijit.byId(id);
        if(controller){
            controller.dispatcher(context,action);
        }
    },
	
	destroyStoreManager: function(uniquePageName){
		var id = uniquePageName+"_store_id";
		var storeManager = dijit.byId(id);
		if ( storeManager) storeManager.destroy();
	},
    
    destroyController: function(uniquePageName){
		var id = uniquePageName+"_controller_id";
		var controller = dijit.byId(id);
		if (controller != undefined){
			controller.destroy();
		}
	},
	
	destroyEventTables: function(pageDiv){
		var portletDivArray = this.getAllPortletsOnPage(pageDiv);
		
		for(var i in portletDivArray){
			var portletDiv = portletDivArray[i];
			var iscPortlets = dojo.query( 'table[name="IscPortlet"]', portletDiv );
	        if(iscPortlets.length!=1){
	            continue;
	        }
	        var iscPortlet = iscPortlets[0];
	        var portletData = iscPortlet.getAttribute("portletdataobject");
	        eval( 'var portletDataObject = ' + portletData);
	        var pii = portletDataObject.basePii;
			var id = pii+"_portlet_events_dijit";
			
			var events = dijit.byId(id);
			if(events){
				var eventsTableParentNode = events.domNode.parentNode;
				var oldPortletContentTable = dojo.query( 'table:first-child', eventsTableParentNode )[0];
				oldPortletContentTable.style.display="";
				events.destroy();
			}
		}
	
	},
	
	leaveCustomizeMode: function( pageDiv ) {
		// removes the visual aspects of Customize mode
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;
		
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
        var uniquePageName = pageDataObject.uniquePageName;

		var count = this.pagesInCustomMode[uniquePageName];
		count--;
		this.pagesInCustomMode[uniquePageName] = count;
		//destroy wire table
		if(count==0){
			this.destroyWireTable(uniquePageName);
			this.destroyStoreManager(uniquePageName);
            this.destroyController(uniquePageName);
			this.destroyEventTables(pageDiv);			
		}
		
		pageDiv.modelObject.setPageShowingEditMode( false );
		pageDiv.modelObject.setPageInEditMode( false );
		var layoutRoot = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if ( typeof layoutRoot == 'undefined' || !layoutRoot ) {
			console.log( "error: layout root not found" )
			return;
		}
		// find and hide sizer bars (this works for page sizers as well)
		dojo.query( 'td[class^="isc-layout-sizebar-"]', layoutRoot ).forEach(
			function( i ) {
				dojo.style( i, 'visibility', 'hidden' );
			}
		);
		// toggle display of save/cancel buttons for this page
        dojo.query( 'td.isc-table-toolbar-buttonbar', pageDiv ).forEach(
			function( i ) {
				dojo.removeClass( i, 'isc-table-toolbar-buttonbar' );
				dojo.addClass( i, 'isc-table-toolbar-buttonbar-hide' );
			}
		);
		// toggle dropdown menu items. see note in enterCustomizeMode about IE bug
		var dropDownMenu = parent.taskbar.dojo.byId( 'PageAction' );
		dropDownMenu.selectedIndex = 0;
		for ( var i=0; i<dropDownMenu.options.length; i++ ) {
			if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-hide' ) {
				dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-show';
			} else if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-show' ) {
				dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-hide';
			}
		}
		var portlets = UIElement.getElementsByName( pageDiv, "PortletFragment" );
		for ( var i=0; i<portlets.length; i++ ) {
			customizer.takePortletOutCustomizeMode( portlets[i] );
		}
	},
	
	destroyEventsAndWiresObjectsOnCancel: function( pageDiv ) {
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;
		
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
		var uniquePageName = pageDataObject.uniquePageName;
		this.destroyWireTable(uniquePageName);
		this.destroyStoreManager(uniquePageName);
		this.destroyController(uniquePageName);
		this.reloadStoreData=false;

	},
	destroyEventsAndWiresObjectsOnSave: function( pageDiv ) {
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;
		
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
		var referencePageName = pageDataObject.referencePageName;

		this.destroyPiis(referencePageName,this.piiContainerArray);
		this.destroyWireTable(referencePageName);
		this.destroyStoreManager(referencePageName);
		this.destroyController(referencePageName);
		this.reloadStoreData=true;

	},
	
	destroyPiis : function(uniquePageName,piiArray) {
		for (var i=0; i<piiArray.length; i++) {
			
			var pii = piiArray[i];
			var id = pii+"_portlet_events_dijit";
			var eventsTable  = dijit.byId(id);
			
			var storeManagerId = uniquePageName+"_store_id";
			var storeManager = dijit.byId(storeManagerId);
			var eventStore = storeManager.getEventsStore();

			if(eventsTable){
               
				eventsTable.destroy();
				dijit.registry.remove(id);
				var publishId = id + "_publish";
				var publish = dijit.byId(publishId);
				if (publish) {
					publish.destroy();
				}

				var subscribeId = id + "_subscribe";
				var subscribe = dijit.byId(subscribeId);
				if (subscribe) {
					subscribe.destroy();
				}

				var publishEventTableId = id + "_publish_eventTable";
				var publishEventTable = dijit.byId(publishEventTableId);
				if (publishEventTable) {
					publishEventTable.destroy();
				}

				var subscribeEventTableId = id + "_subscribe_eventTable";
				var subscribeEventTable = dijit.byId(subscribeEventTableId);
				if (subscribeEventTable) {
					subscribeEventTable.destroy();
				}

				function onItem(item){
          
					var eventId =eventStore.getValue(item,"id");
					
					var publishEventEnableCheckBoxId = id + "_publish_eventTable_"+eventId+"_enableCheckBox";
					var publishEventEnableCheckBox = dijit.byId(publishEventEnableCheckBoxId);
					if(publishEventEnableCheckBox) {
						publishEventEnableCheckBox.destroy();
					}

					var publishEventParamTreeId = id + "_publish_eventTable_"+eventId+"_paramTree";
					var publishEventParamTree = dijit.byId(publishEventParamTreeId);
					if(publishEventParamTree) {
						publishEventParamTree.destroy();
					}

					var subscribeEventEnableCheckBoxId = id + "_subscribe_eventTable_"+eventId+"_enableCheckBox";
					var subscribeEventEnableCheckBox = dijit.byId(subscribeEventEnableCheckBoxId);
					if(subscribeEventEnableCheckBox) {
						subscribeEventEnableCheckBox.destroy();
					}

					var subscribeEventParamTreeId = id + "_subscribe_eventTable_"+eventId+"_paramTree";
					var subscribeEventParamTree = dijit.byId(subscribeEventParamTreeId);
					if(subscribeEventParamTree) {
						subscribeEventParamTree.destroy();
					}
					
				};
				eventStore.fetch({pii: pii, onItem: onItem});
				eventsTable = null;
			}
		}
	},
	
	takePortletOutCustomizeMode: function( portletDiv) {
		var iscPortletDiv = dojo.query( 'table[name="IscPortlet"]', portletDiv );
		var portletData = iscPortletDiv[0].getAttribute( 'portletdataobject' );
		eval( 'var pageDataObject = ' + portletData );
		var basePii=pageDataObject.basePii;
	
		if ( portletDiv.tagName.toLowerCase() != 'div' ) {
			console.log( 'yikes! expecting a DIV in customizer.putPortletInCustomizeMode() but got a ' + portletDiv.tagName );
			return;
		}
		var header = dojo.query( 'table[name="portletHeaderTable"]', portletDiv )[0];
		if ( header === undefined ) return; // nothing here to work on...
		var span = dojo.query( 'span', header )[0];
		dojo.style( span, 'cursor', '' );
		dojo.disconnect( span.event );
		customizer.togglePortletTitleButtons( header,basePii, true);
		// TODO: if the portlet is empty window, do we need to set the window name and hide
		// the titlebar? or does the showEmptyWindows() in makePageRelative() always
		// fix this for us?
	},
	addLayoutSizers: function( pageDiv ) {
		// in pixel based layouts, add right and bottom sizers to allow sizing of entire layout
		var table = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		// check if edge sizers are already here from previous editing
		var nameCheck = table.rows[0].cells[table.rows[0].cells.length - 1].getAttribute( 'name' );
		if ( nameCheck != null && nameCheck.match( /^layoutsizer/ ) != null ) return;
		var td = customizer.createSizer( 'row' );
		td.setAttribute( 'name', 'layoutsizerRight' );
		var tr = customizer.createSizer( 'col' );
		var td2 = dojo.query( 'td', tr )[0];
		td2.setAttribute( 'name', 'layoutsizerBottom' );
		dojo.query( 'td', tr )[0].setAttribute( 'name', 'layoutsizerBottom' );
		var cornerimage = document.createElement( 'IMG' );
		cornerimage.src = '/ibm/console/images/isclite/content/isc_grabbies_corner.gif';
		var corner = document.createElement( 'TD' );
		corner.className = 'isc-layout-sizebar-corner';
		corner.setAttribute( 'name', 'layoutsizerCorner' );
		corner.appendChild( cornerimage );
		tr.appendChild( corner );
		var rowspan = table.rows.length;
		var colspan = table.rows[table.rows.length - 1].cells.length;
		if ( rowspan > 1 ) td.rowSpan = rowspan;
		if ( colspan > 1 ) td2.colSpan = colspan;
		table.rows[0].appendChild( td );
		table.tBodies[0].appendChild( tr );
	},
	togglePortletTitleButtons: function( portletTitleBar,basePii,isPP ) {
	
		this.initEventsAndWiresClasses();
		// toggle display of portlet title bar controls
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		
		var inEditMode = currentPageDiv.modelObject.isPageInEditMode();
		for ( var i=0; i<portletTitleBar.rows[0].cells.length; i++ ) { //DO NOT skip first cell anymore
			//Reason for the change: 208968 - GVT: 'Create new page' cann't be displayed in Hebrew
			//skipping the first cell is working in case we have LTR language, but in RTL case we should skip the last cell(thats the portlet title actually)
			//as it seems here we do not have information about the language orientation, I am checking for the appropriate class - 'isc-portlet-titlebar-button'
			//as we only take care of the buttons here, this change should be working fine
			var td = portletTitleBar.rows[0].cells[i];
			
			if(td.className != 'isc-portlet-titlebar-button' && td.className != 'isc-layout-portlet-titlebar-customizer-icon-hide')
			{
				continue;
			}
			var link = td.getElementsByTagName( 'A' )[0];
			var show = 'isc-portlet-titlebar-button';
			var hide = 'isc-layout-portlet-titlebar-customizer-icon-hide';
			var linkName = link.getAttribute( 'name' );
			if ( linkName === null ) linkName = '';
			if ( linkName == 'IscPortletEvents' ) {
				//td.className = ( inEditMode ) ? show : hide;
                td.className = hide;
                if(inEditMode){
                    var pageData = currentPageDiv.getAttribute( 'pagedataobject' );
		    eval( 'var pageDataObject = ' + pageData );
		    var uniquePageName = pageDataObject.uniquePageName;
		   var storeManagerId = uniquePageName+"_store_id";
		
                    var storeManager = dijit.byId(storeManagerId);
		    
                    if(storeManager){
                       storeManager.showEventIconsWithPublishEvents(td,basePii, isPP);
                    }
                }
				// attach event handler for events button
				if ( ! link.onclickevent ) {
					link.onclickevent = dojo.connect( link, "onclick", customizer, "hideShowEvents" );
				}
			}else if ( linkName.match( /^IscCustomizer.*Split$/ ) != null ) {
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for splitter buttons
				if ( ! link.onclickevent ) {
					link.onclickevent = dojo.connect( link, "onclick", customizer, "splitter" );
				}
			} else if ( linkName == 'IscCustomizerDelete' ) {
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for delete button
				if ( ! link.onclickevent ) {
					link.onclickevent = dojo.connect( link, "onclick", customizer, "deleter" );
				}
			} else if ( linkName == 'IscCustomizerReplace' ) {
				
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for delete button
				if ( ! link.onclickevent ) {
					link.onclickevent = dojo.connect( link, "onclick", customizer, "replacePortlet" );
				}
			} else if ( linkName == 'IscHelp'){
                td.className=show;
            } else {
				td.className = ( inEditMode ) ? hide : show;
			}
		}
	},
	checkIfPageDiv: function( node ) {
		// used as a filter function to id page divs
		return ( node.nodeName == 'DIV' && node.getAttribute( 'name' ) == 'IscPage' );
	},
	checkIfPortlet: function( node ) {
		// used as a filter function to id portlet divs
		return ( node.nodeName == 'DIV' && node.getAttribute( 'name' ) == 'PortletFragment' );
	},
	getAllPortletsOnPage: function( pageDiv ) {
		var portlets = new Array();
		var divs = pageDiv.getElementsByTagName( 'DIV' );
		for ( var i=0; i<divs.length; i++ ) {
			if ( divs[i].getAttribute( 'name' ) == 'PortletFragment' ) {
				portlets.push( divs[i] );
			}
		}
		return portlets;
	},
	getContainingPageDiv: function( node ) {
		return customizer.getAncestors( node, customizer.checkIfPageDiv, true );
	},
	getContainingPortlet: function( node ) {
		// used from portlet headers to get containing portlet DIV
		return customizer.getAncestors( node, customizer.checkIfPortlet, true );
	},
	getPortletHeaderHeight: function( portletDiv ) {
		// find the rendered height of the portlet header bar
		var tr = dojo.query( 'td.isc-portlet-titlebar', portletDiv )[0].parentNode;
		return dojo.marginBox( tr ).h;
	},
	checkIfContainerTable: function( node ) {
		// used as a filter function to id container tables
		return ( node.nodeName == 'TABLE' && ( node.className.match( /^isc-layout-(stretchy-)?(container|root-table)$/ ) != null ) );
	},
	checkIfRootTable: function( node ) {
		return ( node.nodeName == 'TABLE' && ( node.className.match( /^isc-layout-(stretchy-)?root-table$/ ) != null ) );
	},
	getOrientation: function( node ) {
		// return which orientation of container this node is in
		// node is some element in the portlet or portlet decoration
		// or a sizer component or a container table
		// note that this *might* not match PAA but this is what makes sense here
		// this assumes a distilled layout!!
		// TODO: make sure this handles an unsplit root correctly...	
		if ( ! customizer.checkIfContainerTable( node ) ) {
			node = customizer.getAncestors( node, customizer.checkIfContainerTable, true );
		}
		if ( ( ( node.className.match( /-root-table$/ ) != null ) && ( node.rows.length < 3 ) ) ||
				( ( node.className.match( /-container$/ ) != null ) && ( node.rows.length == 1 ) ) ) {
			return 'row';
		} else {
			return 'col';
		}
	},
	isOrthogonal: function( node ) {
		// return bool reflecting if this node's orientation is orthogonal
		// to the current sizing direction
		var thisOrientation = customizer.getOrientation( node );
		return ( thisOrientation != customizer.sizerOrientation );
	},
	sendPortletSize: function( div ) {
		var width = 0;
		var height = 0;
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );

		customizer.calcRelativePortletPercent( div );
		width = parseInt( div.style.width ); // TODO - compare to API
		height = parseInt( div.style.height );

		if ( ! currentPageDiv.modelObject.isPageInEditMode() ) {
       		var pii = dojo.query( 'table[name="IscPortlet"]', div )[0].modelObject.portletData.basePii;
			customizer.setTempResizeStore(
				currentPageDiv.modelObject.pageData.uid,
				pii, width, height );
		} else {
			div.sizeSent = true;
			// normal customizer mode saving
			var uid = currentPageDiv.modelObject.pageData.tid;
			var url = '/ibm/console/customizer.do?action=resize'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + currentPageDiv.modelObject.pageData.uniquePageName
					+ '&windowId=' + div.id
					+ '&width1=' + width
					+ '&height1=' + height;
			if ( uid ) url += '&uid=' + uid;
			url = encodeURI( url );
			dojo.xhrGet( {
				url: url,
				load: function( type, data, evt ) { },
				handleAs: "text"
			} );
		}
	},
	getAdjacentPortlets: function( sizerTd, side ) {
		// return an array of portlet divs that share an edge with the sizer TD
		// side is either "previous" or "next"
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		if ( customizer.smallestX != null && customizer.smallestY != null ) {
			customizer.smallestX[side] = 100000;
			customizer.smallestY[side] = 100000;
		}
		var portletDivs = new Array();
		function checkTdForWindow( windowTd ) {
			if( dojo.hasClass( windowTd, 'isc-layout-window' ) ) {
				// this TD is a window containing a portlet.  add that portlet DIV to the array
				var div = dojo.query( 'div[name="PortletFragment"]', windowTd )[0];
				div.sizeSent = false;
				var origwidth = parseInt( dojo.style( div, 'width' ) );
				var origheight = parseInt( dojo.style( div, 'height' ) );
				if ( customizer.smallestX != null && customizer.smallestY != null ) {
					if ( origwidth < customizer.smallestX[side] ) customizer.smallestX[side] = origwidth;
					if ( origheight < customizer.smallestY[side] ) customizer.smallestY[side] = origheight;
				}
				// store original size
				div.setAttribute( 'origwidth', origwidth );
				div.setAttribute( 'origheight', origheight );
				portletDivs.push( div );
				return;
			} else if ( windowTd.className.match( /^isc-layout-sizebar-/ ) != null ) {
				// this is a sizer - ignore it
				return;
			} else if ( windowTd.className == '' ) {
				// this TD should contain a table - need to recurse
				var table = dojo.query( 'table:first-child', windowTd )[0];
				if ( table.className.match( /^isc-layout-(stretchy-)?(container|root-table)$/ ) != null ) {
					findTdsInTable( table );
				} else {
					// ERROR: we have a stray table
					return;
				}
			}
		}
		function findTdsInTable( table ) {
			if ( customizer.isOrthogonal( table ) ) {
				// check all cells in both row and col orientation
				for ( var r=0; r<table.rows.length; r++ ) {
					for ( var c=0; c<table.rows[r].cells.length; c++ ) {
						checkTdForWindow( table.rows[r].cells[c] );
					}
				}
			} else {
				// need to only check endcells for orthogonal orientations
				if ( side == 'previous' ) {
					// for previous side we check last cell contents
					checkTdForWindow( table.rows[table.rows.length - 1].cells[table.rows[table.rows.length - 1].cells.length - 1] );
				} else {
					// for next side we check first cell contents
					checkTdForWindow( table.rows[0].cells[0] );
				}
			}
		}
		var sizerTdName = sizerTd.getAttribute( 'name' );
		if ( ( sizerTdName != null ) && ( sizerTdName.match( /^layoutsizer/ ) != null ) ) {
			// start the recursion...
			findTdsInTable( customizer.getFirstAncestorByTag( sizerTd, 'TABLE' ) );
		} else {
			var windowTd = null;
			// find the starting TDs on either side of the sizer
			if ( side == 'previous' ) {
				if ( customizer.sizerOrientation == 'row' ) {
					windowTd = customizer.getPreviousSiblingElement( sizerTd, 'TD' );
				} else {
					windowTd = dojo.query( 'td', customizer.getPreviousSiblingElement( sizerTd.parentNode, 'TR' ) )[0];
				}
			} else if ( side == 'next' ) {
				if ( customizer.sizerOrientation == 'row' ) {
					windowTd = customizer.getNextSiblingElement( sizerTd, 'TD' );
				} else {
					windowTd = dojo.query( 'td', customizer.getNextSiblingElement( sizerTd.parentNode, 'TR' ) )[0];
				}
			} else {
				return null;
			}
			// start the recursion...
			checkTdForWindow( windowTd );
		}
		return portletDivs;
	},
	createSizer: function( orientation ) {
		// create a sizer to be used when adding new windows during splitting
		// orientation is "col" or "row"
		var newSizerCell = document.createElement( 'TD' );
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		newSizerCell.style.visibility = 'visible';
		newSizerCell.event = dojo.connect( newSizerCell, "onmousedown", customizer, "sizeMouseDown" );
		var newSizerImage = document.createElement( 'IMG' );
		newSizerCell.appendChild( newSizerImage );
		if ( orientation == 'col' ) {
			// need a TR, TD, image
			var newSizerRow = document.createElement( 'TR' );
			newSizerCell.className = 'isc-layout-sizebar-horizontal';
			newSizerImage.src = '/ibm/console/images/isclite/content/isc_grabbies_horz.gif';
			newSizerRow.appendChild( newSizerCell );
			return newSizerRow;
		} else {
			// only need a TD with image
			newSizerCell.className = 'isc-layout-sizebar-vertical';
			newSizerImage.src = '/ibm/console/images/isclite/content/isc_grabbies_vert.gif';
			return newSizerCell;
		}
	},
	insertPortletSM: function( placeHolderTd, ajaxdata ) {
		// this uses SMUtils code to place content gotten from an AJAX update
		// into a placeholder for that portlet.  The placeholder must be a TD
		// with one DIV inside it.  The DIV should have sizes on it already in pixel mode.
		// also requires the TABLE inside the DIV
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = dojo.query( 'div', placeHolderTd )[0];
		if ( typeof portletDiv == 'undefined' || !portletDiv ) {
			// console.log( "insertPortletSM: the placeHolderTd doesn't have the DIV it needs in it" );
			return; // broken placeholder
		}
		portletDiv.setAttribute( 'name', 'PortletFragment' );
		var portletTable = document.createElement( 'TABLE' );
		portletDiv.innerHTML = '';
		portletDiv.appendChild( portletTable );
		// get id and pageid from ajax data
		var tempDiv = document.createElement( 'DIV' );
		tempDiv.innerHTML = ajaxdata;
		var newPortletFragment = dojo.query( 'div[name="PortletFragment"]', tempDiv )[0];
		portletDiv.id = newPortletFragment.id;
		portletDiv.style.overflow = 'auto';
		portletDiv.setAttribute( 'pageid', newPortletFragment.getAttribute( 'pageid' ) );
		portletTableInTempDiv = dojo.query( 'table[name="IscPortlet"]', newPortletFragment )[0];
		for ( var i=0; i<portletTableInTempDiv.attributes.length; i++ ) {
			portletTable.setAttribute( portletTableInTempDiv.attributes[i].name, portletTableInTempDiv.attributes[i].value );
		}
		tempDiv = null;
		portletDiv.modelObject = new Portlet( currentPageDiv.modelObject, portletTable );
		// call SM code to update the content
		IscPages.UpdatePortletFragments( ajaxdata );
		customizer.sendPortletSize( portletDiv );
		customizer.putPortletInCustomizeMode( portletDiv );				
	},
	/*--- start splitter code ---*/
	splitter: function( event ) {
		var currentTarget = event.currentTarget;
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = customizer.getContainingPortlet( currentTarget );
		// make sure that the first window size gets sent at the first split
		if ( ! portletDiv.sizeSent ) customizer.sendPortletSize( portletDiv );
		portletDiv.sizeSent = false;
		var urlOrientation = 'horizontal';
		if ( event.currentTarget.getAttribute( 'name' ) == 'IscCustomizerVertSplit' ) urlOrientation = 'vertical';
		// AJAX and get the picker portlet
		var uid = currentPageDiv.modelObject.pageData.tid;
		var url = '/ibm/console/customizer.do?action=split'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + currentPageDiv.modelObject.pageData.uniquePageName
					+ '&windowId=' + portletDiv.id
					+ '&orientation=' + urlOrientation;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		dojo.xhrGet( {
			url: url,
			handleAs: "text",
			load: function( response, ioargs ) { customizer.splitterpart2( currentTarget, response ) }
		} );
	},
	splitterpart2: function( clickedTarget, data ) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = customizer.getContainingPortlet( clickedTarget );
		var currentRow = customizer.getFirstAncestorByTag( portletDiv, 'TR' );
		var orientation = customizer.getOrientation( portletDiv );
		var currentSpaceWidth = '';
		var currentSpaceHeight = '';
		var newSpace1Height = '';
		var newSpace1Width = '';
		var newSpace2Height = '';
		var newSpace2Width = '';
		var containerClassName = 'isc-layout-container';
		// store pixel sizes
		currentSpaceWidth = dojo.contentBox( portletDiv.parentNode ).w;
		currentSpaceHeight = dojo.contentBox( portletDiv.parentNode ).h;
		newSpace1Width = Math.floor( currentSpaceWidth / 2 ) - 3;
		newSpace2Width = currentSpaceWidth - 6 - newSpace1Width;
		newSpace1Height = Math.floor( currentSpaceHeight / 2 ) - 3;
		newSpace2Height = currentSpaceHeight - 6 - newSpace1Height;
		var urlOrientation = 'horizontal';
		if ( clickedTarget.getAttribute( 'name' ) == 'IscCustomizerVertSplit' ) urlOrientation = 'vertical';

		// start assembling the placeholder that will eventually get the picker
		var newPortletWindow = document.createElement( 'TD' );
		newPortletWindow.className = 'isc-layout-window';
		var chooserDiv = document.createElement( 'DIV' );
		chooserDiv.setAttribute( 'name', 'PortletFragment' );
		chooserDiv.style.zoom = 1;
		newPortletWindow.appendChild( chooserDiv );

		// figure out allocation of space and DOM changes and make them
		chooserDiv.style.overflow = 'auto';
		if ( urlOrientation == 'horizontal' ) { // horizontal split
			var sizer = customizer.createSizer( 'col' );
			var newRow = document.createElement( 'TR' );
			newRow.appendChild( newPortletWindow );
			portletDiv.style.height = newSpace1Height + 'px';
			chooserDiv.style.width = currentSpaceWidth + 'px';
			chooserDiv.style.height = newSpace2Height + 'px';
			customizer.calcRelativePortletPercent( portletDiv );
			customizer.calcRelativePortletPercent( chooserDiv );
			if ( orientation == 'row') {
				// horizontal split on a row cell - must nest a new column table container
				// add a nested table with 2 rows and a sizer, single window cell in each row
				// put chooser in lower cell and move portlet to upper cell
				var nextSibling = portletDiv.parentNode.nextSibling; // might be null
				var containerTd = document.createElement( 'TD' );
				containerTd.style.padding = '0px';
				containerTd.style.height = '100%';				
				var containerTable = document.createElement( 'TABLE' );
				containerTable.className = containerClassName;
				var containerTbody = document.createElement( 'TBODY' );
				var newRow1 = document.createElement( 'TR' );
				var newRow2 = document.createElement( 'TR' );
				containerTd.appendChild( containerTable );
				containerTable.appendChild( containerTbody );
				containerTbody.appendChild( newRow1 );
				newRow2.appendChild( newPortletWindow );
				newRow1.appendChild( portletDiv.parentNode ); // move current portlet into the new table
				dojo.place( sizer, newRow1, 'after' ); // add sizer
				dojo.place( newRow2, sizer, 'after' ); // add sizer
				if ( nextSibling == null ) {
					currentRow.appendChild( containerTd );
				} else {
					dojo.place( containerTd, nextSibling, 'before' );
				}
			} else {
				// horizontal split on a column cell - add a new column window cell (including row)
				// add a row with a sizer and a row with a new window cell with chooser in it
				dojo.place( sizer, currentRow, 'after' );
				dojo.place( newRow, sizer, 'after' );
			}
		} else {  // vertical split
			var sizer = customizer.createSizer( 'row' );
			portletDiv.style.width = newSpace1Width + 'px';
			chooserDiv.style.width = newSpace2Width + 'px';
			chooserDiv.style.height = currentSpaceHeight + 'px';
			customizer.calcRelativePortletPercent( portletDiv );
			customizer.calcRelativePortletPercent( chooserDiv );
			if ( orientation == 'row') {
				// vertical split on a row of cells - add a new row cell
				// add a sizer cell and an empty/chooser window cell to the current row
				dojo.place( sizer, portletDiv.parentNode, 'after' );
				dojo.place( newPortletWindow, sizer, 'after' );
			} else {
				// vertical split on a column of cells - must nest a new row container/table
				// add a nested table with 1 row, two window cells with sizer
				// move this portlet to left cell and put chooser in the right cell
				var nextSibling = portletDiv.parentNode.nextSibling; // might be null
				var containerTd = document.createElement( 'TD' );
				containerTd.style.padding = '0px';
				var containerTable = document.createElement( 'TABLE' );
				containerTable.className = containerClassName;
				var containerTbody = document.createElement( 'TBODY' );
				var newRow = document.createElement( 'TR' );
				containerTd.appendChild( containerTable );
				containerTable.appendChild( containerTbody );
				containerTbody.appendChild( newRow );
				newRow.appendChild( portletDiv.parentNode ); // move current portlet into the new table
				dojo.place( sizer, portletDiv.parentNode, 'after' ); // add sizer
				dojo.place( newPortletWindow, sizer, 'after' );  // add new window
				if ( nextSibling == null ) {
					currentRow.appendChild( containerTd );
				} else {
					dojo.place( containerTd, nextSibling, 'before' );
				}
			}
		}
		// insert the portlet with SM code
		customizer.insertPortletSM( newPortletWindow, data );
		// reconcile sizes
		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer split' );
	},
	/*--- end splitter code ---*/
	/*--- start drag and drop code ---*/
	dndMouseDown: function( event ) {
		// start dnd - hide portlet and build a proxy to drag around
		customizer.draggedPortlet = customizer.getFirstAncestorByTag( event.currentTarget, 'DIV' );
		// set the drag proxy size to the pixel/rendered size of the TD containing the portlet
		customizer.sourceWindowWidth = dojo.contentBox( customizer.draggedPortlet.parentNode ).w;
		customizer.sourceWindowHeight = dojo.contentBox( customizer.draggedPortlet.parentNode ).h;
		var position = dojo.coords( customizer.draggedPortlet, true );
		// build proxy for dragging around...
		var alltables = customizer.draggedPortlet.getElementsByTagName( 'TABLE' );
		var portletHeaderTable;
		for ( var i=0; i<alltables.length; i++ ) {
			if ( alltables[i].getAttribute( 'name' ) == 'portletHeaderTable' ) {
				portletHeaderTable = alltables[i].cloneNode( true );
				break;
			}
		}

    // A DIV wrapper for both portlet drag div and iframe
    // This DIV will cover the entire page...
		customizer.dragProxyDiv = document.createElement( 'DIV' );
		customizer.dragProxyDiv.style.width = "100%";
    // a big number for the height to cover the page
		customizer.dragProxyDiv.style.height = "2000px";
		customizer.dragProxyDiv.style.left = '0px';
		customizer.dragProxyDiv.style.top = '0px';
		customizer.dragProxyDiv.style.position = "absolute";

    // portlet drag div 
		customizer.dragProxy = document.createElement( 'DIV' );

		customizer.dragProxy.className = 'isc-layout-customizer-dnd-proxy';
		customizer.dragProxy.style.width = customizer.sourceWindowWidth;
		customizer.dragProxy.style.height = customizer.sourceWindowHeight;
		customizer.dragProxy.style.left = ( position.x - 1 ) + 'px';
		customizer.dragProxy.style.top = ( position.y - 1 ) + 'px';
		portletHeaderTable.className = 'isc-portlet-titlebar-bkg';
		customizer.dragProxy.appendChild( portletHeaderTable );
		customizer.dragProxyDiv.appendChild( customizer.dragProxy );

    // IFrame div for iframe
    // This div and iframe will cover the entire page
		customizer.dragProxyIFrameDiv = document.createElement( 'DIV' );
		customizer.dragProxyIFrameDiv.style.top = "0";
		customizer.dragProxyIFrameDiv.style.left = "0";
		customizer.dragProxyIFrameDiv.style.width = "100%";
		customizer.dragProxyIFrameDiv.style.height = "100%";
		customizer.dragProxyIFrameDiv.style.position = "absolute";
		customizer.dragProxyIFrameDiv.zIndex = "9993";

    var dragProxyIFrame = document.createElement( 'IFRAME' );
		dragProxyIFrame.style.position = "absolute";
		dragProxyIFrame.style.width = "100%";
		dragProxyIFrame.style.height = "100%";
		dragProxyIFrame.style.zIndex = "9994";
		if ( dojo.isMozilla ) {
			dragProxyIFrame.style.display = "none";
		}
		dragProxyIFrame.style.backgroundColor = "transparent";
		dragProxyIFrame.style.filter = "alpha(opacity: 0.3)";
		dragProxyIFrame.style.opacity = "0";
		dragProxyIFrame.setAttribute('frameborder','0');
		dragProxyIFrame.setAttribute('border','0');
		dragProxyIFrame.setAttribute('scrolling','no');
		dragProxyIFrame.setAttribute('src', '');

		customizer.dragProxyIFrameDiv.appendChild(dragProxyIFrame);
		customizer.dragProxyDiv.appendChild(customizer.dragProxyIFrameDiv);
		customizer.dragProxyIFrame = dragProxyIFrame;
		dojo.body().appendChild(customizer.dragProxyDiv);

		// hide the selected portlet
		customizer.draggedPortlet.style.visibility = 'hidden';
		// get ready to move stuff around
		customizer.dragProxy.clickOriginX = event.pageX;
		customizer.dragProxy.clickOriginY = event.pageY;
		customizer.dragProxy.deltaX = position.x -1 - event.pageX;
		customizer.dragProxy.deltaY = position.y -1 - event.pageY;
		customizer.dndonmousemove = dojo.connect( document, "onmousemove", customizer, "dndThresholdMouseMove" );
		customizer.dndonmouseup = dojo.connect( document, "onmouseup", customizer, "dndThresholdMouseUp" );

		event.preventDefault();   // stop text selection
		return false;
	},
	dndThresholdMouseUp: function( event ) {
		// if the mouse button is released before crossing the 3 pixel threshold we stop and clean up
		dojo._destroyElement( customizer.dragProxyDiv );
		customizer.dragProxyDiv = null;
		//unhide the portlet
		customizer.draggedPortlet.style.width = customizer.sourceWindowWidth;
		customizer.draggedPortlet.style.height = customizer.sourceWindowHeight;
		customizer.draggedPortlet.style.visibility = 'visible';
		dojo.disconnect( customizer.dndonmousemove );
		dojo.disconnect( customizer.dndonmouseup );
		customizer.draggedPortlet = null;
		event.preventDefault();   // stop text selection
		return false;
	},
	dndThresholdMouseMove: function( event ) {
		// when first starting we wait to see if the dragging moves more than 3 pixels
		// once that happens we set up drop proxies, etc.
		if ( dojo.isMozilla ) {
			// for Firefox, need to hide iframe and then make it visible for it to
			// go on top of the applet
			customizer.dragProxyIFrame.style.display='none';
		}
		if ( Math.abs( customizer.dragProxy.clickOriginX - event.pageX ) > 3 ||
				Math.abs( customizer.dragProxy.clickOriginY - event.pageY ) > 3 ) {
			dojo.disconnect( customizer.dndonmousemove );
			dojo.disconnect( customizer.dndonmouseup );
			customizer.dndonmousemove = dojo.connect( document, "onmousemove", customizer, "dndMouseMove" );
			customizer.dndonmouseup = dojo.connect( document, "onmouseup", customizer, "dndMouseUp" );
			customizer.dndonclick = dojo.connect( document, "onclick", customizer, "dndClick" );
			// set body cursor so it doesn't flicker
			dojo.body().style.cursor = 'move';
			// find all the portlets on this page except the one being dragged and set up drop
			// and highlight indicator proxies
			var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
			var rootTable = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", currentPageDiv )[0];
			var alldivs = dojo.query( 'div[name="PortletFragment"]', currentPageDiv );
			for ( var i=0; i<alldivs.length; i++ ) {
				if ( alldivs[i] != customizer.draggedPortlet ) {
					var targetWindow = alldivs[i];
					var targetWidth = dojo.contentBox( targetWindow.parentNode ).w;
					var targetHeight = dojo.contentBox( targetWindow.parentNode ).h;
					var position = dojo.coords( targetWindow, true );
					var highlightproxy = document.createElement( 'DIV' );
					var eventproxy = document.createElement( 'DIV' );
					eventproxy.proxiedTarget = targetWindow; // store reference (is this the memory leak?)
					eventproxy.highlightProxy = highlightproxy; // store reference
					eventproxy.className = 'isc-layout-customizer-dnd-eventtarget';
					highlightproxy.className = 'isc-layout-customizer-dnd-dropzone';
					highlightproxy.style.height = targetHeight;
					eventproxy.style.height = targetHeight;
					highlightproxy.style.zoom = 1;
					eventproxy.style.zoom = 1;
					// handle box model differences btwn FF and IE (border width inside or outside)
					if ( dojo.isIE ) {
						highlightproxy.style.width = targetWidth + 4;
						eventproxy.style.width = targetWidth + 4;
						highlightproxy.style.left = position.x - 3;
						highlightproxy.style.top = position.y;
						eventproxy.style.left = position.x - 3;
						eventproxy.style.top = position.y;
					} else {
						highlightproxy.style.width = targetWidth;
						eventproxy.style.width = targetWidth;
						highlightproxy.style.left = position.x - 6;
						highlightproxy.style.top = position.y - 3;
						eventproxy.style.left = position.x - 6;
						eventproxy.style.top = position.y - 3;
					}
					eventproxy.setAttribute( 'name', 'targetproxies' );
					highlightproxy.setAttribute( 'name', 'targetproxies' );
					dojo.connect( eventproxy, "onmousemove", customizer, "dndDropTargetMouseOver" );
					dojo.connect( eventproxy, "onmouseout", customizer, "dndDropTargetMouseOut" );
					dojo.place( highlightproxy, rootTable, 'after');
					dojo.place( eventproxy, rootTable, 'after');
				}
			}
			dojo.style( currentPageDiv, 'position', '' ); // temporarily remove to work around IE bug
		}
		event.preventDefault();   // stop text selection
		return false;
	},
	dndDropTargetMouseOver: function( event ) {
		// highlight drop zone proxies as we mouse over them with a dragged portlet
		var eventproxy = event.currentTarget;
		eventproxy.highlightProxy.className = 'isc-layout-customizer-dnd-dropzone-highlight';
		customizer.currentTargetPortlet = eventproxy.proxiedTarget;
		event.preventDefault();   // stop text selection
		return true;
	},
	dndDropTargetMouseOut: function( event ) {
		// undo the highlighting
		var eventproxy = event.currentTarget;
		eventproxy.highlightProxy.className = 'isc-layout-customizer-dnd-dropzone';
		customizer.currentTargetPortlet = null;
		event.preventDefault();   // stop text selection
		return true;
	},
	dndMouseMove: function( event ) {
		// animate the drag proxy to move with the cursor
		// for firefox, need to reset the iframe display for it to go on top of applet
		if ( dojo.isMozilla ) {
			customizer.dragProxyIFrame.style.display='none';
			customizer.dragProxyIFrame.style.display='block';
		}
		customizer.dragProxy.style.left = ( event.pageX + customizer.dragProxy.deltaX ) + 'px';
		customizer.dragProxy.style.top = ( event.pageY + customizer.dragProxy.deltaY ) + 'px';
		event.preventDefault();   // stop default behaviour
		return true;
	},
	dndMouseUp: function( event ) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		// we've moved more than 3 pixels and the portlet has now been dropped
		// we clean up the proxies and decide if it was dropped on a valid drop zone
		// if so we swap portlets - otherwise just put it back
		dojo.style( currentPageDiv, 'position', 'absolute' );  // replace what was temporarily removed to work around IE bug

		dojo._destroyElement( customizer.dragProxyIFrame );
		dojo._destroyElement( customizer.dragProxyIFrameDiv );
		dojo._destroyElement( customizer.dragProxy );
		dojo._destroyElement( customizer.dragProxyDiv );
		customizer.dragProxy = null;
		customizer.dragProxyDiv = null;
		customizer.dragProxyIFrame = null;
		customizer.dragProxyIFrameDiv = null;
		// FIXME: this leaks around 5460K of memory in IE for the complex layout each time
		// need a new cleaner way to do this
		var divs = currentPageDiv.getElementsByTagName( 'DIV' );
		var proxyDivs = new Array();
		for ( var i=0; i<divs.length; i++ ) {
			if ( divs[i].className.match( /^isc-layout-customizer-dnd-/ ) != null ) {
				proxyDivs[ proxyDivs.length ] = divs[i];
			}
		}
		for ( var i=0; i<proxyDivs.length; i++ ) {
			// may need to remove the event handlers first?
			proxyDivs[i].parentNode.removeChild( proxyDivs[i] );
		}
		dojo.disconnect( customizer.dndonmousemove );
		dojo.disconnect( customizer.dndonmouseup );
		dojo.disconnect( customizer.dndonclick );
		// unset the body cursor
		dojo.body().style.cursor = '';
		var sourceCell = customizer.draggedPortlet.parentNode;
		if ( customizer.currentTargetPortlet != null ) {
			// swap the portlets
			var targetCell = customizer.currentTargetPortlet.parentNode;
			customizer.originalTargetWidth = dojo.marginBox( customizer.currentTargetPortlet ).w;
			customizer.originalTargetHeight = dojo.marginBox( customizer.currentTargetPortlet ).h;
			var portletstandin = document.createElement( 'DIV' );
			portletstandin.style.width = dojo.style( targetCell, 'width' );
			portletstandin.style.height = dojo.style( targetCell, 'height' );
			var removedTargetPortlet = customizer.replaceNode( customizer.currentTargetPortlet, portletstandin );
			removedTargetPortlet.style.width = customizer.sourceWindowWidth;
			removedTargetPortlet.style.height = customizer.sourceWindowHeight;
			customizer.calcRelativePortletPercent( removedTargetPortlet );
			var removedSourcePortlet = customizer.replaceNode( customizer.draggedPortlet, removedTargetPortlet );
			removedSourcePortlet.style.width = customizer.originalTargetWidth;
			removedSourcePortlet.style.height = customizer.originalTargetHeight;
			customizer.calcRelativePortletPercent( removedSourcePortlet );
			customizer.replaceNode( portletstandin, removedSourcePortlet );
			portletstandin = null;
			// send framework event to notify portlets that want to know about resizes
			iscPortlet.sendResizeEvent( 'customizer portlet swap' ); // this will also audit sizes

			// tell the server side what was done 
			var uid = currentPageDiv.modelObject.pageData.tid;
			// TODO: replace this (and all other occurences) with the new dojo content param...
			var url = "/ibm/console/customizer.do?action=dad"
						+ "&moduleRef=" + currentPageDiv.modelObject.pageData.moduleRef
						+ "&pageId=" + currentPageDiv.modelObject.pageData.uniquePageName
						+ "&windowId=" + customizer.draggedPortlet.id
						+ "&destWindowId=" + customizer.currentTargetPortlet.id;
			if ( uid ) url += '&uid=' + uid;
			url = encodeURI( url );
			dojo.xhrGet( {
				url: url,
				load: function( type, data, evt ) { },
				handleAs: "text"
			} );
		} else {
			// no swap - restore original size
			/*
			customizer.draggedPortlet.style.width = customizer.sourceWindowWidth;
			customizer.draggedPortlet.style.height = customizer.sourceWindowHeight;
			*/
		}
		customizer.draggedPortlet.style.visibility = 'visible';
		customizer.draggedPortlet = null;
		customizer.currentTargetPortlet = null;
		event.preventDefault();   // stop default behaviour
		return true;
	},
	dndClick: function( event ) {
		// we don't want click events - using mouse up and down instead
		dojo.disconnect( customizer.dndonclick );
		event.preventDefault();   // stop default behaviour
		return true;
	},
	/*--- end drag and drop code ---*/
	/*--- start sizing code ---*/
	sizeMouseDown: function( event ) {
		customizer.sizePage = IscPages.getPageElementById( IscPages.currentPageId );
		customizer.sizeOriginX = event.pageX;
		customizer.sizeOriginY = event.pageY;
		customizer.smallestX = new Array();
		customizer.smallestY = new Array();
		var sizerTd = event.currentTarget;
		var sizerTdName = sizerTd.getAttribute( 'name' );
		// set body cursor so it doesn't flicker
		customizer.cursor = dojo.style( sizerTd, 'cursor' );
		dojo.body().style.cursor = customizer.cursor;
		if ( ( sizerTdName != null ) && ( sizerTdName.match( /^layoutsizer/ ) != null ) ) {
			if ( sizerTdName == 'layoutsizerRight' ) {
				customizer.sizerOrientation = 'row';
			} else {
				customizer.sizerOrientation = 'col';
			}
			customizer.previousNeighbors = customizer.getAdjacentPortlets( sizerTd, 'previous' );
			customizer.nextNeighbors = [];
		} else {
			customizer.sizerOrientation = customizer.getOrientation( sizerTd );
			customizer.previousNeighbors = customizer.getAdjacentPortlets( sizerTd, 'previous' );
			customizer.nextNeighbors = customizer.getAdjacentPortlets( sizerTd, 'next' );
		}
		customizer.minPortletHeight = 40; // this is determined by the height of the draggie image for now
		customizer.minPortletWidth = 40; // this is determined by the width of the draggie image for now
		// customizer.minPortletHeight = customizer.getPortletHeaderHeight( customizer.previousNeighbors[0] );

		var pageHeight = dojo.dnd.getViewport().h + 'px';
		var moveEventTarget = document.createElement( 'DIV' );
		moveEventTarget.id = 'customizerSizeEventTarget';
		moveEventTarget.style.position = 'absolute';
		moveEventTarget.style.top = '0px';
		moveEventTarget.style.left = '0px';
		moveEventTarget.style.width = '100%';
		moveEventTarget.style.height = pageHeight;
		moveEventTarget.style.filter = "alpha(opacity: 0.3)";
		moveEventTarget.style.backgroundColor = "white";
		moveEventTarget.style.opacity = 0;
		moveEventTarget.style.zIndex = 10000;

		// IFrame div for iframe
		customizer.moveEventIFrameDiv = document.createElement( 'DIV' );
		customizer.moveEventIFrameDiv.style.top = "0px";
		customizer.moveEventIFrameDiv.style.left = "0px";
		customizer.moveEventIFrameDiv.style.width = "100%";
		customizer.moveEventIFrameDiv.style.height = pageHeight;
		customizer.moveEventIFrameDiv.style.position = "absolute";
		customizer.moveEventIFrameDiv.style.zIndex = "9999";

		var moveEventIFrame = document.createElement( 'IFRAME' );
		moveEventIFrame.style.position = "absolute";
		moveEventIFrame.style.top = "0px";
		moveEventIFrame.style.left = "0px";
		moveEventIFrame.style.width = "100%";
		moveEventIFrame.style.height = pageHeight;
		moveEventIFrame.style.zIndex = "9998";
		moveEventIFrame.style.backgroundColor = "transparent";
		moveEventIFrame.style.filter = "alpha(opacity: 0.3)";
		moveEventIFrame.style.opacity = "0";
		if ( dojo.isMozilla ) {
			moveEventIFrame.style.display = "none";
		}
		moveEventIFrame.setAttribute('frameborder','0');
		moveEventIFrame.setAttribute('border','0');
		moveEventIFrame.setAttribute('scrolling','no');
		moveEventIFrame.setAttribute('src', '');
		customizer.moveEventIFrame = moveEventIFrame;
		customizer.moveEventIFrameDiv.appendChild(moveEventIFrame);

		customizer.ondragstart = dojo.connect( document, "ondragstart", dojo, "stopEvent", false );
		customizer.onselectstart = dojo.connect( document, "onselectstart", dojo, "stopEvent", false );
		customizer.sizeonmousemove = dojo.connect( moveEventTarget, "onmousemove", customizer, "sizeMouseMove" );
		customizer.sizeonmouseup = dojo.connect( moveEventTarget, "onmouseup", customizer, "sizeMouseUp" );

		// add the iframe div first
		dojo.place( customizer.moveEventIFrameDiv, dojo.body(), 'first' );
		dojo.place( moveEventTarget, dojo.body(), 'first' );

		event.preventDefault();
		return false;
	},
	sizeMouseMove: function( event ) {
		if ( dojo.isMozilla && customizer.moveEventIFrame ) {
			customizer.moveEventIFrame.style.display = "none";
			customizer.moveEventIFrame.style.display = "block";
		}
		var deltaX = Number( event.pageX - customizer.sizeOriginX );
		var deltaY = Number( event.pageY - customizer.sizeOriginY );
		if ( customizer.smallestX == undefined || customizer.smallestX == null ) {
			// if the mouse was released outside the browser window behave reasonably
			customizer.sizeMouseUp( event );
			return;
		}
		if ( deltaX < -( customizer.smallestX['previous'] - customizer.minPortletWidth ) ) {
			deltaX = -( customizer.smallestX['previous'] - customizer.minPortletWidth );
		} else if ( deltaX > ( customizer.smallestX['next'] - customizer.minPortletWidth ) ) {
			deltaX = customizer.smallestX['next'] - customizer.minPortletWidth;
		}
		if ( deltaY < -( customizer.smallestY['previous'] - customizer.minPortletHeight ) ) {
			deltaY = -( customizer.smallestY['previous'] - customizer.minPortletHeight );
		} else if ( deltaY > ( customizer.smallestY['next'] - customizer.minPortletHeight ) ) {
			deltaY = customizer.smallestY['next'] - customizer.minPortletHeight;
		}
		// size portlets previous to this sizer
		for ( var i=0; i<customizer.previousNeighbors.length; i++ ) {
			var div = customizer.previousNeighbors[i];
			var origHeight = Number( div.getAttribute( 'origheight' ) );
			if ( customizer.sizerOrientation == 'row' ) {
				var origWidth = Number( div.getAttribute( 'origwidth' ) );
				div.style.width = ( origWidth + deltaX ) + 'px';
			} else {
				div.style.height = ( origHeight + deltaY ) + 'px';
			}
		}
		// size portlets after to this sizer
		for ( var i=0; i<customizer.nextNeighbors.length; i++ ) {
			var div = customizer.nextNeighbors[i];
			var origHeight = Number( div.getAttribute( 'origheight' ) );
			if ( customizer.sizerOrientation == 'row' ) {
				var origWidth = Number( div.getAttribute( 'origwidth' ) );
				div.style.width = ( origWidth - deltaX ) + 'px';
			} else {
				div.style.height = ( origHeight - deltaY ) + 'px';
			}
		}
		event.stopPropagation();  // stop event bubbling up
		event.preventDefault();   // stop default behaviour
		return true;
	},
	sizeMouseUp: function( event ) {
		// finished dragging
		// send AJAX to the sever for each changed size
		// clean up events and references
		dojo.disconnect( customizer.sizeonmousemove );
		dojo.disconnect( customizer.sizeonmouseup );
		dojo.disconnect( customizer.onselectstart );
		dojo.disconnect( customizer.ondragstart );
		customizer.onselectstart = null;
		customizer.ondragstart = null;
		dojo._destroyElement( dojo.byId( 'customizerSizeEventTarget' ) );

		// process size changes for all effected portlets
		if ( customizer.previousNeighbors ) {
			for ( var i=0; i<customizer.previousNeighbors.length; i++ ) {
				customizer.sendPortletSize( customizer.previousNeighbors[i] );
			}
		}
		if ( customizer.nextNeighbors ) {
			for ( var i=0; i<customizer.nextNeighbors.length; i++ ) {
				customizer.sendPortletSize( customizer.nextNeighbors[i] );
			}
		}
		// clean up stored row sizes
		customizer.sizeonmousemove = null;
		customizer.sizeonmouseup = null;
		customizer.previousNeighbors = null;
		customizer.nextNeighbors = null;
		customizer.sizerOrientation = null;
		customizer.smallestX = null;
	 	customizer.smallestY = null;
		customizer.minPortletHeight = null;
		customizer.cursor = null;
		customizer.sizePage = null;
		dojo.body().style.cursor = ''; // unset the body cursor
		event.preventDefault();   // stop default behaviour
		// send framework event to notify portlets that want to know about resizes
		iscPortlet.sendResizeEvent( 'customizer portlet resize' );

		// clean up iframe div
		dojo._destroyElement( customizer.moveEventIFrame );
		customizer.moveEventIFrame = null;
		dojo._destroyElement( customizer.moveEventIFrameDiv );
		customizer.moveEventIFrameDiv = null;
		return true;
	},
	/*--- end sizing code ---*/
	/*--- start deletion code ---*/
	getSiblingContainers: function( windowTd ) {
		var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
		var siblingTds = [];
		for ( var r=0; r<containingTable.rows.length; r++ ) {
			for ( var c=0; c<containingTable.rows[r].cells.length; c++ ) {
				var td = containingTable.rows[r].cells[c];
				if ( td !== windowTd && td.className.match(/^isc-layout-sizebar-/ ) == null ) {
					siblingTds.push( td );
				}
			}
		}
		return siblingTds;
	},
	removeWindow: function( windowTd ) {
		// handle removing a window in either orientation and a sizer
		var deletedWindow = null;
		var deletedSizer = null;
		if ( customizer.getOrientation( windowTd ) == 'col' ) {
			// remove a TR and a TD and a sizer TR/TD
			deletedWindow = windowTd.parentNode;
			if ( deletedWindow.rowIndex == 0 ) {
				// this is the first row (and there are more)
				if ( deletedWindow.cells[deletedWindow.cells.length - 1].className.match(/^isc-layout-sizebar-/ ) != null ) {
					// if the TR to delete is the top one in a pixel-based root table, need to move the right edge sizer
					deletedWindow.parentNode.rows[2].appendChild( deletedWindow.cells[deletedWindow.cells.length - 1] );
				}
				deletedSizer = deletedWindow.parentNode.rows[1];
			} else {
				deletedSizer = deletedWindow.parentNode.rows[deletedWindow.rowIndex - 1];
			}
		} else {
			// remove a TD and a sizer TD
			deletedWindow = windowTd;
			if ( windowTd.cellIndex == 0 ) {
				// this is the first cell
				deletedSizer = deletedWindow.parentNode.cells[1];
			} else {
				deletedSizer = deletedWindow.parentNode.cells[deletedWindow.cellIndex - 1];
			}
		}
		dojo._destroyElement( deletedWindow );
		dojo._destroyElement( deletedSizer );
	},
	moveWindowUp: function( windowTd ) {
		var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
		var containingTd = containingTable.parentNode;
		var leaker = customizer.replaceNode( containingTd, windowTd );
		dojo._destroyElement( leaker ); // prevent IE memory leak
	},
	mergeContainerUp: function( containerTd ) {
		var childrenToMove = [];
		var containerToReplace = null; // either TD or TR
		var containerToMerge = containerTd.getElementsByTagName( 'TABLE' )[0];
		var containingTable = customizer.getAncestors( containerTd, customizer.checkIfContainerTable, true );
		if ( customizer.getOrientation( containerToMerge ) == 'col' ) {
			childrenToMove = containerToMerge.rows;
			containerToReplace = containingTable.parentNode.parentNode; // a TR
			if ( containerToReplace.cells[containerToReplace.cells.length - 1].className.match(/^isc-layout-sizebar-/ ) != null ) {
				// if the TR to replace is the top one in a pixel-based root table, need to move the right edge sizer
				childrenToMove[0].appendChild( containerToReplace.cells[containerToReplace.cells.length - 1] );
			}
		} else {
			childrenToMove = containerToMerge.rows[0].cells;
			containerToReplace = containingTable.parentNode; // a TD
		}
		containerToReplace.style.display = 'none';
		while ( childrenToMove.length > 0 ) {
			dojo.place( childrenToMove[0], containerToReplace, 'before' );
		}
		dojo._destroyElement( containerToReplace );
	},
	getSpaceRecipients: function( windowTd ) {
		// get adjacent sizers but only within the same container
		var nextSizer = null;
		var previousSizer = null;
		if ( customizer.sizerOrientation == 'col' ) {
			var rowIndex = windowTd.parentNode.rowIndex;
			if ( rowIndex != 0 ) previousSizer = windowTd.parentNode.parentNode.rows[rowIndex - 1].cells[0];
			nextSizer = windowTd.parentNode.parentNode.rows[rowIndex + 1];
			if ( nextSizer === undefined ) nextSizer = null;
// TODO: take out layout sizer stuff
			if ( nextSizer != null &&
					nextSizer.cells[0].getAttribute( 'name' ) != null &&
					nextSizer.cells[0].getAttribute( 'name' ).match( /^layoutsizer/ ) != null ) {
				// this would be the layout sizer in pixel mode - ignore it
				nextSizer = null;
			} else if ( nextSizer != null ) {
				nextSizer = nextSizer.cells[0];
			}
		} else {
			var cellIndex = windowTd.cellIndex;
			if ( cellIndex != 0 ) previousSizer = windowTd.parentNode.cells[cellIndex - 1];
			nextSizer = windowTd.parentNode.cells[cellIndex + 1];
			if ( nextSizer == undefined ) nextSizer = null;
// TODO: take out layout sizer stuff
			if ( nextSizer != null &&
					nextSizer.getAttribute( 'name' ) != null &&
					nextSizer.getAttribute( 'name' ).match( /^layoutsizer/ ) != null ) {
				// this would be the layout sizer in pixel mode - ignore it
				nextSizer = null;
			}
		}
		var previousPortlets = [];
		var nextPortlets = [];
		if ( previousSizer != null ) {
			previousPortlets = customizer.getAdjacentPortlets( previousSizer, 'previous' );
		}
		if ( nextSizer != null ) {
			nextPortlets = customizer.getAdjacentPortlets( nextSizer, 'next' );
		}
		return { previous: previousPortlets, next: nextPortlets };
	},
	deleter: function( event ) {
		// thus assumes a distilled layout
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = customizer.getContainingPortlet( event.currentTarget );
		var portletId = portletDiv.id;
        this.removeWiresFromSummaryTable(currentPageDiv,portletDiv);
		var windowTd = portletDiv.parentNode;
		customizer.sizerOrientation = customizer.getOrientation( windowTd );
		var deltaX = dojo.contentBox( windowTd ).w;
		var deltaY = dojo.contentBox( windowTd ).h;
		var siblingTds = customizer.getSiblingContainers( windowTd );
		var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
		var portletsToSize = customizer.getSpaceRecipients( windowTd );
		if ( customizer.checkIfRootTable( containingTable ) ) {
			// window is in root container
			if ( siblingTds.length == 0 ) {
				// since this is the last portlet on the page, replace it with the picker
				customizer.replacePortlet( event );
				return true;
			} else {
				customizer.removeWindow( windowTd );
			}
		} else if ( siblingTds.length > 1 ) {
			// more than one sibling - just remove this window
			customizer.removeWindow( windowTd );
		} else if ( dojo.hasClass( siblingTds[0], 'isc-layout-window' ) ) {
			// the one sibling contains just a window/portlet
			// move that window into the parent container
			customizer.moveWindowUp( siblingTds[0] );
		} else {
			// the one sibling contains a container
			// put the children of the container in the parent and throw away the container
			customizer.mergeContainerUp( siblingTds[0] );
		}
		var uid = currentPageDiv.modelObject.pageData.tid;
		var url = '/ibm/console/customizer.do?action=delete'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + currentPageDiv.modelObject.pageData.uniquePageName
					+ '&windowId=' + portletId;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );
		// if there are both previous and next porlets, half the width (for row) or height (for col) 
		// and add that to all of the porlets.  If there are only previous or only next portlets,
		// add the full width/height to the portlets.
		var deltaX1 = deltaX;
		var deltaY1 = deltaY;
		if ( portletsToSize.previous.length != 0 && portletsToSize.next.length != 0 ) {
			deltaX1 = Math.floor( ( deltaX + 6 ) / 2 );
			deltaX = Number( deltaX - deltaX1 );
			deltaY1 = Math.floor( ( deltaY + 6 ) / 2 );
			deltaY = Number( deltaY - deltaY1 );
		} else {
			deltaX += 6;
			deltaY += 6;
			deltaX1 += 6;
			deltaY1 += 6;
		}
		// process size changes for all effected portlets
		for ( var i=0; i<portletsToSize.previous.length; i++ ) {
			var width = dojo.contentBox( portletsToSize.previous[i] ).w;
			var height = dojo.contentBox( portletsToSize.previous[i] ).h;
			var newWidth = Number( width + deltaX );
			var newHeight = Number( height + deltaY );
			if ( customizer.sizerOrientation == 'col' ) {
				portletsToSize.previous[i].style.height = newHeight + 'px';
			} else {
				portletsToSize.previous[i].style.width = newWidth + 'px';
			}
			customizer.sendPortletSize( portletsToSize.previous[i] );
		}
		for ( var i=0; i<portletsToSize.next.length; i++ ) {
			var width = dojo.contentBox( portletsToSize.next[i] ).w;
			var height = dojo.contentBox( portletsToSize.next[i] ).h;
			var newWidth = Number( width + deltaX1 );
			var newHeight = Number( height + deltaY1 );
			if ( customizer.sizerOrientation == 'col' ) {
				portletsToSize.next[i].style.height = newHeight + 'px';
			} else {
				portletsToSize.next[i].style.width = newWidth + 'px';
			}
			customizer.sendPortletSize( portletsToSize.next[i] );
			
		}
		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer portlet deletion' );
		customizer.sizerOrientation = null;
		
		//enable/disable the Save button according to the presence of Portlet Picker on the page
		var pickers = document.getElementsByName("thepicker");
		if(pickers.length == 0)
		{
			var saveBtn = document.getElementById("page.titlebar.save");
			saveBtn.disabled = false;
		}		
	},
    
    removeWiresFromSummaryTable:function(pageDiv,portletDiv){
        var pageData = pageDiv.getAttribute( 'pagedataobject' );
        eval( 'var pageDataObject = ' + pageData );
        var uniquePageName = pageDataObject.uniquePageName;
        var pii = null;
        for(i in portletDiv.childNodes){
            if(portletDiv.childNodes[i].tagName == "TABLE"){
                pii = portletDiv.childNodes[i].modelObject.portletData.basePii;
                break;
            }
        }
        if(piiToPWIMap[pii]){
     	    pii = piiToPWIMap[pii];
        }
        
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = dijit.byId(storeManagerId);

		var wireStore = storeManager.getWiresStore();
               var eventStore = storeManager.getEventsStore();
        
        function removeWires(item){
	if(item.type=="wire"){
            var currWireSource = wireStore.getValue(item,"wireSource");
            var currWireSourcePii = wireStore.getValue(currWireSource,"pii");
	     var currWireTarget = wireStore.getValue(item,"wireTarget");
            var currWireTargetPii = wireStore.getValue(currWireTarget,"pii");
           
	   if(pii==currWireSourcePii){	
            // deleteing wires with source pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table

               wireStore.deleteItem(item, true);

            }
	     if(pii==currWireTargetPii){	
            // deleteing wires with target pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table

               wireStore.deleteItem(item, true);
		}
            }
		};
        
        if(pii && pii != null){
            wireStore.fetch({type:'wire',onItem: removeWires});
        }
        
         function removeEvents(item){
            if(item.type=="event"){
            if(pii==item.pii[0]){
            // deleteing wires with source pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table
              eventStore.deleteItem(item);
              storeManager.updateSourceEventDialog();
              
            }
	   } 
		};
        
        if(pii && pii !=null){
            eventStore.fetch({type:'event',onItem: removeEvents});
        }
    
    },
	/*--- end deletion code ---*/
	/*--- begin replacement code ---*/
	replacePortlet: function( event ) {
	        
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pd = currentPageDiv.getAttribute( 'pagedataobject' );
		
		eval( 'var pageDataObject = ' + pd );
		
		var portletDiv = customizer.getContainingPortlet( event.currentTarget );
		var iscPortlets = dojo.query( 'table[name="IscPortlet"]', portletDiv );
		if(iscPortlets.length!=1){
			return;
			}
		var iscPortlet = iscPortlets[0];
		var portletData = iscPortlet.getAttribute("portletdataobject");
		eval( 'var portletDataObject = ' + portletData);
		var portletPii = portletDataObject.basePii;
     	
		
		var theRealPWI = piiToPWIMap[portletDiv.id];
		var uniquePageName = pageDataObject.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = dijit.byId(storeManagerId);
		var eventStore = storeManager.getEventsStore();
	        var piiToDestroy=[];
		
		var items=eventStore._arrayOfAllItems;
	        for(var i=0; i<items.length;i++){
		
			       var item=items[i];
			      
			if(item!=null){	
			        itemId=item.id[0];
				
			        var index=itemId.indexOf('h');
			        index=index-1;
			        var pii=itemId.substring(0,index);
			       
				if(typeof(theRealPWI)=="undefined"){
					theRealPWI=portletPii;
				}
				
				
			       if(item.type=="event" || item.type=="parameter" ){
					if(pii==theRealPWI){
						eventStore.deleteItem(item);	
					}
				}
			
			}
		}
		
	      piiToDestroy.push(theRealPWI);
	      eventStore.save();
             
	        this.removeWiresFromSummaryTable(currentPageDiv,portletDiv);	     
	        this.destroyPiis(uniquePageName,piiToDestroy);
	 	this.destroyEventTables(currentPageDiv);
          	
		var portletId = portletDiv.id;
		var windowTd = portletDiv.parentNode;
		portletDiv.innerHTML = '';
		var uid = currentPageDiv.modelObject.pageData.tid;
		var url = '/ibm/console/customizer.do?action=deletecontent'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + currentPageDiv.modelObject.pageData.uniquePageName
					+ '&windowId=' + portletId;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		dojo.xhrGet( {
			url: url,
			load: function( response, ioargs ) { customizer.insertPortletSM( windowTd, response ) },
			handleAs: "text"
		} );
	},
	/*--- end replacement code ---*/
	/*--- begin setup wires drag and drop code ---*/
	setupWiresDragAndDrop: function( curPageElem ){
		
       
		dojo.query("div.page-show", curPageElem).forEach(function(node){
            
            dojo.addClass(node, 'wire-dnd-target-portlet');
			
			var wireDropTarget = new com.ibm.isclite.dnd.Target(node, { createTargetNode: false, accept: ['eventItem']});
		});
	},
	setupPorltetWiresDragAndDrop: function(node){
            dojo.require("com.ibm.isclite.data.custom.eventsandwires.WireDNDManager");
            dojo.require("com.ibm.isclite.dnd.Target");
            dojo.addClass(node, 'wire-dnd-target-portlet');
			var wireDropTarget = new com.ibm.isclite.dnd.Target(node, { createTargetNode: false, accept: ['eventItem']});
    },
	/*--- end setup wires drag and drop code ---*/
    
     hideShowEvents : function (event) {
  
        var portletDiv = customizer.getContainingPortlet( event.currentTarget );

        var iscPortlets = dojo.query( 'table[name="IscPortlet"]', portletDiv );
        if(iscPortlets.length!=1){
            return;
        }
        var iscPortlet = iscPortlets[0];
        var portletData = iscPortlet.getAttribute("portletdataobject");
        eval( 'var portletDataObject = ' + portletData);
        var pii = portletDataObject.basePii;
     	
        //in new page use the map to get the correct pii
        // when editing page the map is empty
        if(piiToPWIMap[pii]){
     	    pii = piiToPWIMap[pii];
        }
		this.piiContainerArray.push(pii);
 
		var id = pii+"_portlet_events_dijit";
		var portletContentId = portletDataObject.oid+"_portlet_content";
		var portletContentTable = dojo.byId(portletContentId);
		
		var eventsTable  = dijit.byId(id);
		

		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pageData = currentPageDiv.getAttribute( 'pagedataobject' );
		eval( 'var pageDataObject = ' + pageData );
		var uniquePageName = pageDataObject.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = dijit.byId(storeManagerId);
		var eventStore = storeManager.getEventsStore();
		
		if(!eventsTable){
			var nodeRef = document.createElement("div");
			var parentNode = portletContentTable.parentNode;
			parentNode.appendChild(nodeRef);
			nodeRef.id=pii+"_portlet_events_node";
			eventsTable = new com.ibm.isclite.dijit.custom.events.Events( {id:id,uniquePageName:uniquePageName,store:eventStore,pii:pii,
				publishTabLabel:eventsAndWiresNls.events.publishTabLabel,
				subscribeTabLabel:eventsAndWiresNls.events.subscribeTabLabel, 
				eventDescriptionLabel:eventsAndWiresNls.events.eventDescriptionLabel,
				enableTitle:eventsAndWiresNls.events.enableTitle,
				publishedEventsDescriptionLabel :   eventsAndWiresNls.events.publishedEventsDescriptionLabel,
		                subscribedEventsDescriptionLabel:  eventsAndWiresNls.events.subscribedEventsDescriptionLabel,
				eventTitle:eventsAndWiresNls.events.eventTitle}, nodeRef);
    		eventsTable.startup();
			eventsTable.onHide();
		}
		
		var eventsTableParentNode = eventsTable.domNode.parentNode;
        var oldPortletContentTable = dojo.query( 'table:first-child', eventsTableParentNode )[0];
        if(oldPortletContentTable!=portletContentTable){
            //move dijit to new open instance
            //disconect
            eventsTableParentNode.removeChild(eventsTable.domNode);
			//display old portlet content
			oldPortletContentTable.style.display="";
			//move
            var parentNode = portletContentTable.parentNode;
            parentNode.appendChild(eventsTable.domNode);
			eventsTable.onHide();
        }


		var div = eventsTable.domNode;
		eventsTable.showHide();
        if(portletContentTable.style.display=="none"){
			portletContentTable.style.display="";
		}else{
			portletContentTable.style.display="none";
        }
 
	},
	// convert px pages to relative that use pixels and don't rely on browser flow
	makePageRelative: function( pageDiv ) {
		// show empty windows without headers so that sizing can work right
		customizer.showEmptyWindows( pageDiv );
		var rootTable = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		dojo.removeClass( rootTable, 'isc-layout-stretchy-root-table' );
		dojo.addClass( rootTable, 'isc-layout-root-table' );
		pageDiv.style.paddingRight = '0px';
		rootTable.style.marginBottom = '0px';
		var rootTableSize = customizer.getRootTableSize( pageDiv );
		var missingWidths = false;
		var missingHeights = false;
		var portlets = dojo.query( 'table[name="IscPortlet"]', pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			// find any portlets without sizes to see if this is old style percent page
			var w = parseInt( portlets[i].parentNode.style.width );
  			var h = parseInt( portlets[i].parentNode.style.height );
			if ( isNaN( w ) ) {
				missingWidths = true;
			}
			if ( isNaN( h ) ) {
				missingHeights = true;
			}
		}
		if ( ! pageDiv.modelObject.pageData.percentsSet ) {
			var area = customizer.getContentAreaSize( pageDiv );
			var mw = ( area.w / rootTableSize.w );
			var mh = ( area.h / rootTableSize.h );
			for ( var i=0; i<portlets.length; i++ ) {
				if ( ! missingWidths ) {
					var w = parseInt( portlets[i].parentNode.style.width );
					portlets[i].parentNode.style.width = Math.floor( w * mw ) + 'px';
				}
				if ( ! missingHeights ) {
					var h = parseInt( portlets[i].parentNode.style.height );
					portlets[i].parentNode.style.height = Math.floor( h * mh ) + 'px';
				}
			}
			rootTableSize = customizer.getRootTableSize( pageDiv ); // recalc root table size
		}
		var pageMaximized = this.isPageContainsMaximizedPortlet(pageDiv.id);
		// calculate the inital percents and attach them to the portlets
		for ( var i=0; i<portlets.length; i++ ) {
			if ( pageMaximized && !this.isPortletMaximized(portlets[i].parentNode.id) ) {
				// we do not want to calculate portlet percent if page has maximized
				// portlet and this is not the maximized portlet. This will retain the
				// percent in the portlet
				continue;
			} else {
				customizer.calcRelativePortletPercent( portlets[i].parentNode, rootTableSize, missingWidths, missingHeights );
			}
		}
 		if ( dojo.isIE ) { // work around IE rendering bug
 			var windows = dojo.query( 'td.isc-layout-window', rootTable );
 			for ( var i=0; i<windows.length; i++ ) {
 				windows[i].style.height = '1px';
 			}
 		}
		// change container classes so it doesn't act like a noSize page
		var containers = dojo.query( 'table.isc-layout-stretchy-container', rootTable );
		for ( var i=0; i<containers.length; i++ ) {
			dojo.removeClass( containers[i], 'isc-layout-stretchy-container' );
			dojo.addClass( containers[i], 'isc-layout-container' );
		}
		// convert the the percents from above into actual pixel sizes
		customizer.rescaleRelativePage( pageDiv );
		// restore any temp sizings still held in memory
		if ( customizer.tempResizeStore[pageDiv.modelObject.pageData.uid] ) {
			customizer.restorePortletSizes( pageDiv, customizer.tempResizeStore[pageDiv.modelObject.pageData.uid] );
		}
		// set marker flag
		pageDiv.modelObject.pageData.percentsSet = true;
		pageDiv.modelObject.pageData.noSize = false;
		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer initializing relative page' );
	},
	getContentAreaSize: function( pageDiv ) {
		var viewPort = dojo.dnd.getViewport();
		var size = {};
		size.w = viewPort.w - 16; //  - 8;
		var rootTable = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		var top = dojo.coords( rootTable ).t;
		//lets check to see if the table is not visible in the current viewport
		// FIXME:  I think this breaks page sizes in FF 2 & 3
		if (top > viewPort.h)
			top = 0;
		size.h = viewPort.h - top - 16; // FIXME the 12 is the margin-bottom
		// console.log( 'getContentAreaSize returning: ', size.w, size.h );
		return size;
	},
	getRootTableSize: function( node ) {
		var pageDiv = customizer.getContainingPageDiv( node );
		var rootTable = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		rootTable.style.margin = '0px';
		var rootTableSize = dojo.coords( rootTable.tBodies[0] );
		return rootTableSize;
	},
	calcRelativePortletPercent: function( portletDiv, rootTableSize, missingWidths, missingHeights ) {
		if ( rootTableSize == undefined ) rootTableSize = customizer.getRootTableSize( portletDiv );
		var w = 0, h = 0, pw = 0, ph = 0;
		portletDiv.style.overflow = 'auto';
		if ( this.isPortletMaximized(portletDiv.id) ) {
			// portlet is in maximized mode. Set percent to 100
			portletDiv.savedPercent = portletDiv.percent;
			portletDiv.percent = { w: "100", h: "100" };
			return;
		} else if ( this.restoredPortlet ) {
			if ( portletDiv.savedPercent && this.restoredPortlet.portletId == portletDiv.id ) {
				// restore percent, no need to recalculate percent
				portletDiv.percent = portletDiv.savedPercent;
				portletDiv.savedPercent = null;
				return;
			} else if ( this.restoredPortlet.pageId == portletDiv.getAttribute("pageid") ) {
				// this portlet has been restored from Maximized state
				// Skip recalculate...
				return;
			}
		}

		if ( missingWidths ) {
			var size = iscPortlet.getPortletSize( portletDiv );
			pw = size.percents.w;
			w = Math.floor( rootTableSize.w * pw / 100 );
			portletDiv.style.width = w + 'px';
		} else {
			w = parseInt( portletDiv.style.width );
			if ( isNaN( w ) ) {
				w = dojo.contentBox( portletDiv.parentNode ).w;
				// console.log( '  calcRelativePortletPercent missing w for: ', portletDiv );
				// console.log( '     using w: ', w );
				portletDiv.style.width = w + 'px';
			}
			pw = ( w / rootTableSize.w ) * 100;
		}
		if ( missingHeights ) {
			var size = iscPortlet.getPortletSize( portletDiv );
			ph = size.percents.h;
			h = Math.floor( rootTableSize.h * ph / 100 );
			portletDiv.style.height = h + 'px';
		} else {
			h = parseInt( portletDiv.style.height );
			if ( isNaN( h ) ) {
				h = dojo.contentBox( portletDiv.parentNode ).h;
				// console.log( '  calcRelativePortletPercent missing h for: ', portletDiv );
				// console.log( '     using h: ', h );
				portletDiv.style.height = h + 'px';
			}
			ph = ( h / rootTableSize.h ) * 100;
		}
		// console.log( '  calcRelativePortletPercent - setting page percents ', pw, ph );
		portletDiv.percent = { w:pw, h:ph };
	},
	rescaleRelativePage: function( pageDiv ) {
		var portlets = dojo.query( 'table[name="IscPortlet"]', pageDiv );
		var contentsize = customizer.getContentAreaSize( pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			var portletDiv = portlets[i].parentNode;
			if ( !portletDiv.percent ) {
				// portletDiv has no percent, recalculate percent
				customizer.calcRelativePortletPercent( portletDiv, contentsize );
			}
			var size = customizer.percentToPixels( portletDiv.percent, null, contentsize );
			portletDiv.style.width = size.w + 'px';
			portletDiv.style.height = size.h + 'px';
		}
	},
	windowResize: function() {
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		if ( pageDiv == null || typeof pageDiv == undefined ) {
			console.log( "customizer.windowResize: page DOM is not finalized yet" );
			return false;
		}
		if ( pageDiv.modelObject.isNoSizePage() ) return;
		customizer.rescaleRelativePage( pageDiv );
	},
	percentToPixels: function( percent, pageDiv, contentsize ) {
		if ( ! pageDiv == null ) contentsize = customizer.getContentAreaSize( pageDiv );
		var w = Math.floor( percent.w * contentsize.w / 100 );
		var h = Math.floor( percent.h * contentsize.h / 100 );
		return { w: w, h: h };
	},
    init: function() {
        // connect to resize events
		if ( ! customizer.windowResizeEvent ) {
            // this handles browser resizes or navigation area collapsing/restoring
			customizer.windowResizeEvent = dojo.connect( window, 'onresize', customizer, "windowResize" );

		}
    },
	getCategorizedCells: function( table ) {
		var cells = [];
		var used = { w:0, h:0 };
		var isRow = ( table.rows.length == 1 );
		// fixed dimension for rows is row height and for cols is tbody width
		if ( isRow ) {
			used.h = dojo.coords( table, false ).h;
		} else {
			used.w = dojo.coords( table, false ).w;
		}
		for ( var r=0; r<table.rows.length; r++ ) {
			for ( var c=0; c<table.rows[r].cells.length; c++ ) {
				var cell = table.rows[r].cells[c];
				if( dojo.hasClass( cell, 'isc-layout-window' ) ) {
					// this is a window cell containing a portlet
					cell.isPortlet = true;
					cells.push( cell );
				} else if ( cell.className == 'isc-layout-sizebar-vertical' ) {
					// this is a vertical sizer
					var w = dojo.coords( cell ).w;
					if ( w == 25 ) { // workaround size bug in FF2
						w = 7;
					} else if ( w == 24 ) {
						w = 6;
					}
					used.w += w;
				} else if ( cell.className == 'isc-layout-sizebar-horizontal' ) {
					// this is a horizontal sizer
					var h = dojo.coords( cell ).h;
					if ( h == 25 ) { // workaround size bug in FF2
						h = 7;
					} else if ( h == 24 ) {
						h = 6;
					}
					used.h += h;
				} else if ( cell.className == '' ) {
					// this should be a cell containing another layout table
					cell.isPortlet = false;
					cells.push( cell );
				}
			}
		}
		return { cells: cells, used: used };
	},
	fixPortletSizes: function( pageDiv ) {
		/* How this recursion works:
		 *  I am always told the total of my long dimension from above - I
		 *  always have to reconcile it I am either asked what my short
		 *  dimension is or told what to make it I need to make all my parts
		 *  match the short dimension (their long dim) that I know or am given
		 *  To reconcile my long dimension, I ask all but the last one what
		 *  their short dim is.  The last one I tell what to be.
		 */
		if ( this.isPageContainsMaximizedPortlet( pageDiv.id ) ) return; // don't do this on a max'd portlet
		var size = customizer.getContentAreaSize( pageDiv );
		var rootTable = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if ( rootTable.rows.length == 1 ) {
			// work around a quirk in ISC page aggregation that leaves an extra table
			var nextTable = dojo.query( 'table.isc-layout-container', rootTable )[0];
			if ( nextTable && nextTable.rows.length == 1 ) rootTable = nextTable;
		}
		rootTable.style.width = size.w + 'px';
		rootTable.style.height = size.h + 'px';
		rootTable.tBodies[0].style.width = size.w + 'px';
		rootTable.tBodies[0].style.height = size.h + 'px';
		// start the recursion
		if ( rootTable.rows.length == 1 ) {  // if it's a row container
			processThePortlets( rootTable, size.w, size.h );
		} else {
			processThePortlets( rootTable, size.h, size.w );
		}
		// recursion function for finding the portlets and setting sizes
		function processThePortlets( table, l, s ) { // long dim (required) , short dim (optional)
			var isRow = ( table.rows.length == 1 );
			var cells = customizer.getCategorizedCells( table );
			var all = cells.cells;
			var last = all[all.length - 1];
			// if we are given short side we have to enforce it. otherwise enforce used size
			if ( s == null ) s = ( isRow ) ? cells.used.h : cells.used.w;
			// initialize with known used space
			var runningtotal = ( isRow ) ? cells.used.w : cells.used.h;
			for ( var i=0; i<(all.length - 1); i++ ) { // all but the last (or only) one
				if ( all[i].isPortlet ) {
					var div = dojo.query( 'div[name="PortletFragment"]', all[i] )[0];
					if ( isRow ) {
						// portlet widths are already accounted for, just set height
						div.style.height = ( s - 2 ) + 'px';
						runningtotal += parseInt( div.style.width );
					} else {
						// portlet heights are already accounted for, just set width
						div.style.width = ( s - 2 ) + 'px';
						runningtotal += parseInt( div.style.height );
					}
				} else {
					var nextTable = dojo.query( 'table:first-child', all[i] )[0];
					// next container is orthogonal - pass in its long side as this one's short side
					// add its short dimension to the running total
					runningtotal += processThePortlets( nextTable, ( s - 2 ), null ).s;
					if ( dojo.isIE ) all[i].style.height = '1px'; // work around IE bug
				}
			}
			// set the size on the last cell
			var remaining = l - runningtotal;
			if ( remaining < 0 ) {
				remaining = 0;
				console.log( 'in fixPortletSizes: got negative remaining.. ' );
			}
			if ( last.isPortlet ) {
				var div = dojo.query( 'div[name="PortletFragment"]', all[i] )[0];
				if ( isRow ) {
					div.style.height = ( s - 2 ) + 'px';
					div.style.width = remaining + 'px';
				} else {
					div.style.width = ( s - 2) + 'px';
					div.style.height = remaining + 'px';
				}
			} else {
				var nextTable = dojo.query( 'table:first-child', all[i] )[0];
				processThePortlets( nextTable, ( s -2 ), remaining );
				if ( dojo.isIE ) last.style.height = '1px'; // work around IE bug
			}
			return { l:l, s:s };
		}
	},
	addMaximizedPortlet: function(portletId) {
		// portletId - contains 2 vars: portletId and pageId
		if ( !this.isPortletMaximized(portletId) ) {
			this.maximizedPortlets.push(portletId);         
		}                                          
	},        
	isPortletMaximized: function(portletId) {
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].portletId == portletId ) {
				return true;
			}
		}
		return false;                                                               
	},
	isPageContainsMaximizedPortlet: function(pageId) {
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].pageId == pageId ) {
				return true;
			}
		}
		return false;
	},
	setRestoredPortlet: function(portletId) {
		if ( this.isPortletMaximized(portletId) ) {
			// portlet restored, set the var and remove from maximizedPortlet array
			// we use this restoredPortlet when we setup customizer
			this.restoredPortlet = this.removeMaximizedPortlet(portletId);
		}
	},
	removeMaximizedPortlet: function(portletId) {
		var maxPortlet = null;
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].portletId == portletId ) {
				maxPortlet = this.maximizedPortlets[i];
				this.maximizedPortlets.splice(i, 1);
				break;
			}
		}
		return maxPortlet;
	}
};
customizer.init();



function customizerSave(saveAction,uid){
	//If there is a Portlet Picker on the page, show error message and do not proceed with saving
	var thePicker = document.getElementById("thepicker");
	if(thePicker != null)
	{
		var errorMessageTable = document.getElementById("errorMessageTable");
		errorMessageTable.style.display = "";
		return;
	}

	var eventsAndWiresUW = {};
	if ( IscPages && IscPages.getPageElementById ) {
        var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pageData = pageDiv.getAttribute( 'pagedataobject' );
	    eval( 'var pageDataObject = ' + pageData );
	    var uniquePageName = pageDataObject.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
	
		var div = dijit.byId(uniquePageName+"_Wires_Table_ID").domNode;
		div.style.display="none";

		var buttonId =uniquePageName +"_wires_button_id";
		var wireButton = dojo.byId(buttonId);

        if (wireButton) {
            dojo.removeClass(wireButton, 'isc-table-toolbar-buttonbar-hide' );
            dojo.addClass(wireButton,'isc-table-toolbar-buttonbar');

        }

		var storeManager = dijit.byId(storeManagerId); 
        if (storeManager){
            eventsAndWiresUW = storeManager.getUnitOfWork(saveAction);
        }
        
	}
	
	
	
//209836 - don't leave customize mode, the user might want to go back and continue editing the layout	
//	cleanCustomizerResources();
	customizerRedirect(saveAction,uid,eventsAndWiresUW);
}

function customizerCancelEditPage(cancelAction,uid){
	cleanCustomizerResources();
	customizerRedirectEditPage(cancelAction,uid);
}

function customizerRedirectEditPage(action,uid,eventsAndWiresUW){

	var pageIds = uid.split(";");
	var location = "/ibm/console/taskbar.do?pageID=" + pageIds[0] + "&moduleRef=" + pageIds[1] + "&ISC.PAGE_LEAVE_CUSTOMIZER=" + uid;
	if (pageIds.length > 2) {
		location += "&ISC.TID=" + pageIds[2];
	}
	if(eventsAndWiresUW){
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = dojo.toJson(eventsAndWiresUW);
	}

    SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
}

function customizerCancelNewPage(cancelAction,uid){
	cleanCustomizerResources();
	customizerRedirectNewPage(cancelAction,uid);
}

function customizerRedirectNewPage(action,uid,eventsAndWiresUW){
	var location ="/ibm/console/taskbarfragment.do?"+action+"="+uid;
	if(eventsAndWiresUW){
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = dojo.toJson(eventsAndWiresUW);
	}

    SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
}

function customizerRedirect(action,uid,eventsAndWiresUW){
	var location ="/ibm/console/taskbarfragment.do?"+action+"="+uid;
	if(eventsAndWiresUW){
		//var eventsAndWiresUWJson = encodeURIComponent(dojo.toJson(eventsAndWiresUW)); 
		//location+="&eventsAndWiresUW="+eventsAndWiresUWJson;
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = dojo.toJson(eventsAndWiresUW);
	}
   // window.location = location;

    SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);


}
function cleanCustomizerResources(){
	if ( IscPages && IscPages.getPageElementById ) {
        var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
        if ( customizer && customizer.leaveCustomizeMode ) {
                customizer.leaveCustomizeMode( currentPageDiv );
        }
	}
}

